/**************************************************************************
*    CoSy conferencing system, written by Alastair Mayer
*    
*    Copyright (C) 1984 University of Guelph
*
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program; if not, write to the Free Software
*    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*
***************************************************************************/

/*******************************************************
* COSY(tm) Computer-Based Conferencing System          *
* Written by: Keith Winter, Alastair Mayer             *
*******************************************************/
/*
 *   A program to emulate XEDIT for use with CMST on a micro.
 *                              Keith Winter July '84
 */

#include <stdio.h>

char *eof = "EOF:\n\021";
char *prompt = "\021.";
char *ready  = "R;\021\n";
char buff[500];

main(argc, argv)
int argc;
char *argv[];
{
   /* for now, skip error checking */
   cmst(argv[1],argv[2]);
}

cmst(dir,fname)
char *dir,*fname;
{
	switch(*dir) {
		case 'r' : receive(fname); break;
		case 's' : send(fname); break;
	}
}

send(fname)                     /* Send file FNAME */
char *fname;
{
	FILE *fp;
	if((fp = fopen(fname,"r")) == NULL) {
		printf("cmst: Cannot open input file %s\n",fname);
		return;
	}

	fputs(prompt,stdout);
	while(fgets(buff,sizeof(buff),stdin)) {
		if(!fgets(buff,sizeof(buff),fp)) break;
		fputs(buff,stdout);
		fputs(prompt,stdout);
	}
	
	printf(eof);
	fflush(stdout);
	fclose(fp);
}

receive(fname)                  /* Receive file FNAME */
char *fname;
{
	FILE *fp;
	fp = fopen(fname,"a+");
	fputs(prompt,stdout);
	while(fgets(buff,sizeof(buff),stdin)) {
		if (*buff == '\n')
			break;
		fputs(buff,fp);
		fputs(prompt,stdout);
	}
	
	fputs(ready,stdout);
	fflush(stdout);
	fclose(fp);
}
