
/**************************************************************************
*    CoSy conferencing system, written by Alastair Mayer
*    
*    Copyright (C) 1984 University of Guelph
*
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program; if not, write to the Free Software
*    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*
***************************************************************************/

/* validate memo files */
#define BSKSIZ 72
#define HASREAD 1
#define CANTFIND 2
#define NOTREAD 3

main(argc, argv)    /* check all entries in a user's in & out baskets */
int argc;
char *argv[];
{
   FILE *fb, *ft, *fopen();
   char bask[BSKSIZ];

   if (argc < 2) {
      fputs("usage: vmemo name1 [ name2 ... ] \n",stderr);
      exit(0);
      }
   for (i=1; i<argc; i++) {     /* loop through args */
      strcpy(fname,mkpath(MEM_IN,argv[i]);
      strcpy(tmpnm,fname);
      strcat(tmpnm,".VBK");
      /****** C R I T I C A L -- But shouldn't be anyone else on *****/
      if (lock(fname)) {
         fprintf(stderr,"vmemo: can't lock %s\n",fname);
         continue;   /* next user */
         }
      if (link(fname,tmpnm) != 0) {
         perror("vmemo (out.1)");
         continue;   /* next user */
         }
      unlink(fname);  /* don't forget! */
      if ((ft=fopen(tmpnm,"r"))==NULL) {
         perror("vmemo (out.2)");
         unlock(fname);
         continue;   /* next user */
         }
      if ((fb=fopen(fname,"w"))==NULL) {
         perror("vemo (out.3)");
         unlock(fname);
         fclose(ft);
         continue;   /* next user */
         }

      /* everything opened ok, now process the basket */
      
      printf(" ** checking user  '%s'  Memo_out  **\n",argv[i]);
      while (fread(bask,BSKSIZ,1,ft) > 0) {
         sscanf(bask,"%14s%d",tonm,&numb);
         if (!ishere(tonm)) {
            anomaly(tonm,numb,"dest user not here");
            continue;  /* skip */
            }
         if (numgone(numb)) {
            anomaly(tonm,numb,"missing memo file");
            continue;
            }
         okay=YES;
#ifdef DOOUT
         switch (findit(tonm,numb)) {
            HASREAD:
                     bask[21] = 'R';
                     anomaly(tonm,numb,"read, not marked");
                     break;
            CANTFIND: 
                      okay=NO;
                     anomaly(tonm,numb,"not in basket");
                     break;
            NOTREAD:
                     /* that's okay */
                     break;
            }
#endif
         if (okay)
            fwrite(bask,BSKSIZ,1,fb);   /* maybe write it out again */
         }  /* end while */
      fclose(fb);
      fclose(ft);
      unlock(fname);
      /*** E N D   C R I T I C A L ***/
      unlink(tmpnm);
      }  /* end this user */

   printf("vmemo complete.");
}

anomaly(usr,nmr,msg)   /* print error message */
char *usr, *nmr, *msg;
{
   printf("%14s %5d %s\n",usr,nmr,msg);
}

int numgone(nmr)    /* check if memo # nmr exists */
char *nmr;
{
   char memname[60];

   strcpy(memname,"/usr/memo/spool/");
   strcat(memname,nmr);
   return (access(memname));
}


int findit(tnm,nmr,fnm)    /* find nmr from fnm in tnm  */
car *tnm, *nmr, *fnm;
{
   char ibsk[BSKSIZ];
   char denm[NMSIZE], 

    if ((fp=fopen(mkpath(MEM_IN,tnm),"r"))==NULL)
       return (CANTFIND);
    while (fread(ibsk,BSKSIZ,1,fp) > 0) {
      sscanf(ibsk,"%14s%d",denm,&mnum);
      if (mnum==nmr && (strcmp(fnm,denm)==0))  {  /*found it */
         fclose(fp);
         if (ibsk[21]=='R')
            return(HASREAD);
         else
            return(NOTREAD);
         }
    }
      /* got to here, didnt find it */
      return(CANTFIND);
}
