/**************************************************************************
*    CoSy conferencing system, written by Alastair Mayer
*    
*    Copyright (C) 1984 University of Guelph
*
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program; if not, write to the Free Software
*    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*
***************************************************************************/

/*******************************************************
* COSY(tm) Computer-Based Conferencing System          *
* Author:  Alastair J.W. Mayer                         *
*******************************************************/

#include "defs3.h"
#define ABORT_K -13
#include <ctype.h>
#include <setjmp.h>
jmp_buf Env;
jmp_buf A_Env;
char *mkpath();

/* defs.h contains externals & system includes */

/* global definitions */
struct wdtbl *Vocab;

 int  print_flag = OFF;
 int  file_flag = OFF;
 int joined_flag = OFF;
int rd_direc = FWRD_K;
int last_m_read = 0;
int Rd_hdr_flag = OFF;

FILE *ftopic, *fmsgdir;

char username[NMSIZE];
char confname[NMSIZE];
struct cnode *confnode;
char topicname[NMSIZE];
struct tnode *topicnode;

int newcomment, nxtcomment;

struct ctree C_T, *Ct, M_T, *Mt;

ushort Subsys;
char Passwd[NMSIZE] = "";
char *PrtFyl = "/tmp/CPRxxxxxx   ";
char Editor[NMSIZE] = "";
char Up_Prtcl[NMSIZE], Dn_Prtcl[NMSIZE];
int  Terse = 0;
int  Privilege = 3;  /* higher for priv'ed users (eg sysmgr, wizard) */
byte ReadList[TMAX];
int Dev; /* file descr for fast lookups */
FILE *Out, *Prt, *Fyl;
line_ty line;
int LineCnt = 0;  /* for tty paging */
int ColCnt = 0;   /* for line length */
int Paging = YES; /* control paging */
int Naplps = NO;  /* don't display NAPLPS PDIs - filter them */
int PageLen = 20;  /* tty page (screen) size */
int LinWidth = 80; /* tty page width (line length) */
int Filter = YES; /* control char filtering */
int LogComplete = NO;  /* for interrupts during login */
int Conf_err = NO;	/* for inconsistencies in Confs file */
int MailFlag = NO;     /* flag for got new mail */


/* main routine */
extern char **environ;	/* so we can dump the environment */

char *pmesg(), *mesg(), *strcpy();    /* declare these here to make the *
                                       * Berkley compiler happy.  -A.M. */ 
main(argc,argv)   /* arguments used only in 'remote batch COSY' */
int argc;
char *argv[];
{
  int i;
  char *getlogin();
  FILE *fp, *fopen();

  if (chdir(HPATH)) {
     puts(mesg("cosy: can't chdir"));
     exit(-1);
     }
  chdir("..");
/*
  logger(mesg("on - pgm start"));
*/
 /* puts(Version); */
  system("cat StartScreen");
  puts("CoSy Conferencing System");
  puts ("Copyright (c) 1984 University of Guelph");
  puts ("CoSy comes with NO WARRANTY and is distributed under the GNU");
  puts ("General Public License, Version 2");
  puts("     Written by: Alastair JW Mayer");
  fflush(stdout); sleep(2);
  puts("");
  fflush(stdout);
  
  /* Linux login default PATH does not include '.', but we need */
  /* that to run misc cosy helper routines.  So change the default */
  
  putenv("PATH=/usr/local/bin:/bin:/usr/bin:.");

  system(".cosylogin");
#if 0 
  puts("Dumping environment strings:");
  i = 0;
  while (environ[i]) {
	  printf("> %s\n", environ[i++]);
  }
  puts("Done dump.");
#endif
  strcpy(Up_Prtcl,"kermit");
  strcpy(Dn_Prtcl,"kermit");
  Ct = &C_T; Mt = &M_T;

  umask(002);	/* set umask so we get rw-rw-r-- permissions */

  initkw();         /* load up the vocabulary table */
  Subsys = MAIN_SS;
  Ct->ct_first = Ct->ct_last = Mt->ct_first = Mt->ct_last = NULL;
  confnode = NULL; topicnode = NULL;
#ifdef DEBUG
  printf("-keywords initialized\n");
#endif
  Out = stdout;
    startup();
   LogComplete = YES;
   parse(NULL);
   logger("TERMINATE","");
   logger("LOGOFF","");
  }
  
flush()  /* scratch rest of input line */
{
     line.ptr = line.siz + 1; /* to force 'eoln()' true */
}

nimp()  /* stub for Not IMPlemented */
{
     puts(mesg("N.Imp|Sorry, not fully implemented yet."));
}
#include "lock/lock.c"
#include "lock/cantlock.c"
#include "lock/panic.c"
#include "start/newlog.c"
#include "misc/yorn.c"
#include "misc/flist.c"
#include "misc/checkers.c"
#include "start/tymout.c"
#include "misc/pmesg.c"
