/**************************************************************************
*    CoSy conferencing system, written by Alastair Mayer
*    
*    Copyright (C) 1984 University of Guelph
*
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program; if not, write to the Free Software
*    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*
***************************************************************************/

/*******************************************************
* COSY(tm) Computer-Based Conferencing System          *
* Copyright (C) 1983, 1984, 1985, University of Guelph *
* Written by: Alastair J.W. Mayer                      *
*******************************************************/

add_list(ct,nm)  /* build new conf list and tack onto cp */
struct ctree *ct;
char *nm;
{
   char *fname, *mkpath();
   struct cnode *add_cnode();
   struct tnode *mk_tnode();
   char name[NMSIZE];
   FILE *fp, *fopen();
   int i;

   if (ct->ct_last == NULL)
       ct->ct_first = ct->ct_last = add_cnode(nm);
   else
      ct->ct_last = (ct->ct_last->c_next = add_cnode(nm));
   fname = mkpath(HDR,nm);
   if ((fp = fopen(fname,"r")) != NULL) {          /* open conf Header file */
      for (i=1; i<=2; i++) { while ('\n' != getc(fp)) ; }  /*skip 2 lines */
      while (fscanf(fp,"%14s%*[^\n]",name) != EOF)   /* read topic list */
         add_tnode(ct->ct_last, mk_tnode(name,0,0));
      fclose(fp);
      }
   return(0);
 }

fput_clst(fp,cp,new)  /* write topic list */
FILE *fp;
struct cnode *cp;
int new;     /* if being written to new member */
{
   struct tnode *tp;

   fprintf(fp,"%d %s\n",cp->n_topics,cp->c_name);
   tp = cp->first;
   while (tp != NULL) {
     if (new)
         fprintf(fp, "%s %d\n", tp->name, 0);
     else
         fprintf(fp, "%s %d\n", tp->name, tp->count);
      tp = tp->next;
      }
}
