/**************************************************************************
*    CoSy conferencing system, written by Alastair Mayer
*    
*    Copyright (C) 1984 University of Guelph
*
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program; if not, write to the Free Software
*    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*
***************************************************************************/

/*******************************************************
* COSY(tm) Computer-Based Conferencing System          *
* Copyright (C) 1983, 1984, 1985, University of Guelph *
* Written by: Alastair J.W. Mayer                      *
*******************************************************/
join_conf(nm,tpnm) /* join conference <nm> */
char nm[];
char *tpnm;   /* topic name, maybe "" */
{
  FILE *fp, *fopen();
  char *mkpath();
  char c, cn[NMSIZE];
  int found;
  int stat;
  struct cnode *cfind(), *cnd;
  char *fmn; FILE *fmp;
  char cmd[100];  /* command line for system() call */

#ifdef DEBUG
 puts(" in join_conf");
#endif
  quit_conf();   /* keep things 'clean' */
  if ((cnd = cfind(nm)) != NULL) {
     StrCpy(nm,confname);
     confnode = cnd;
     if ((stat = join_topic(tpnm)) == NO) {
        confnode = NULL;
        return (NO);
        }
     else {
     joined_flag = ON;
     if (Subsys != MOD_SS) {
        logger("JOIN",confname);
        Subsys = READ_SS;
        }
     return(YES);
     }
     }
  else {
     found = NO;
     if (numeric(nm)) {
        tout(fmt("%s '%s'.\n",mesg("No@such number"),nm));
        return(NO);
        }
#ifdef DEBUG
 puts("joinconf: searching clist for name");
 fflush(stdout);
#endif
     if ((fp = fopen(mkpath(CLIST),"r")) != NULL)
        while(fscanf(fp,"%c%14s%*[^\n]%*c",&c,cn) != EOF) {
           found = (strcmp(cn,nm) == 0);
           if (found) break;
           }
#ifdef DEBUG
 puts("joinconf: finished searching");
 fflush(stdout);
#endif
     found = (strcmp(cn,nm) == 0);  /* for last (EOF) entry */
     if (fp != NULL) fclose(fp);
     if (found) {
        if (c == 'c' && Privilege < 9) {
            tout(fmt(mesg("Conference$'%s' is closed.\n"),nm));
           return(NO);
           }
        else if (c == 's') /* special */ {
           sprintf(cmd,"%s %s",nm,username); /* pass the username */
           logger("SPECIAL",nm);
           system(cmd);
           logger("QUIT","special");
           return(YES);
           }
        else {
           tout(fmt(mesg("You are$not registered in '%s'. "),nm));
           if (yorn(mesg("Would you like to$register "),'Y')) {
              fmn = mkpath(MEMBR,nm);
      /******* critical - update member list *********/
              lock(fmn);
              if ((fmp=fopen(fmn,"a")) == NULL)
                  unlock(fmn);
              else {
                 fprintf(fmp,"%s\n",username);
                 fclose(fmp);
                unlock(fmn);
               }
     /********* end critical ************/
   quietly:   add_list(Ct,nm);
              joined_flag = ON;
              if (Subsys != MOD_SS) Subsys = READ_SS;
              confnode = Ct->ct_last;
              if (confnode != NULL)
                 strcpy(confname,confnode->c_name);
              logger("JOIN",confname);
              if (confnode->n_topics == 1)
                 return(join_topic(confnode->first->name));
              else
                 return(join_topic(tpnm));
              }
           else if (Privilege > 9) {
                 if (yorn("Quietly ",' ')) goto quietly;
                 }
            else
              return(NO);
           }
        }
      else {
#ifdef DEBUG
  puts("joinconf: - no such conference");
  fflush(stdout);
#endif
         tout(fmt("No conference '%s'.\n",nm));
         return(NO);
         }
      }
}
