/**************************************************************************
*    CoSy conferencing system, written by Alastair Mayer
*    
*    Copyright (C) 1984 University of Guelph
*
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program; if not, write to the Free Software
*    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*
***************************************************************************/

/*******************************************************
* COSY(tm) Computer-Based Conferencing System          *
* Copyright (C) 1984, 1985, University of Guelph       *
* Written by: Tom Smith                                *
* and by: Alastair Mayer                               *
*******************************************************/
j_mv_conf()   /*  get parms for moving (reordering) conf list */
{
   char srce[NMSIZE], dest[NMSIZE];
   while (scan(srce)==NULL)
      getlin(0,"Conference to move:");
   while (scan(dest)==NULL)
      getlin(0,"Move it before:");
   reorder(srce,dest);
}

struct cnode *prefind(nm)
char nm[];
{
    struct cnode *pnd;
#if 0
    if (numeric(nm))
        pnd = Mt->ct_first;
    else
#endif
        pnd = Ct->ct_first;
    if (strcmp(pnd->c_name,nm)==0) {
        pnd = Ct->ct_first;
        return(pnd);
       }
    else {
       while (pnd->c_next != NULL && strcmp(pnd->c_next->c_name,nm) != 0) 
          pnd = pnd->c_next;

       return(pnd);
       }
}

reorder(srce,dest) /* move conf srce before conf dest in list */
char *srce, *dest;
{
char *first = "first", *last = "last";
struct cnode *hnd,
             *inpnd,
             *pnd;

if (strcmp(srce,first)==0)
    strcpy(srce, Ct->ct_first->c_name);
else if (strcmp(srce,last)==0)
   strcpy(srce, Ct->ct_last->c_name);
if (strcmp(dest,first)==0)
   strcpy(dest, Ct->ct_first->c_name);
else if (strcmp(dest,last)==0)
   strcpy(dest,Ct->ct_last->c_name);
if (strcmp(srce,dest) == 0)
   return;   /** dont bother moving before itself **/
if ((strcmp(srce,Ct->ct_first->c_next->c_name) == 0) 
     && (strcmp(dest,Ct->ct_first->c_name) == 0))  {
    hnd = Ct->ct_first->c_next;
    Ct->ct_first->c_next = hnd->c_next;
    hnd->c_next = Ct->ct_first;
    Ct->ct_first = hnd;
    return;
    }
if ((hnd = cfind(srce)) != NULL) {
   pnd = prefind(srce);
   if (pnd != Ct->ct_first)  {
       pnd->c_next = hnd->c_next;
       if (hnd == Ct->ct_last)
           Ct->ct_last = pnd;
       }
   else
       Ct->ct_first = hnd->c_next;
   if ((inpnd = cfind(dest)) != NULL) {
      if (inpnd == Ct->ct_first) {
         hnd->c_next = Ct->ct_first;
         Ct->ct_first = hnd;
         }
      else {
         pnd = prefind(dest);
         hnd -> c_next = pnd->c_next;
         pnd->c_next = hnd;
         }
      }
   else {                  /* reset pointers to original values */
       if (pnd == hnd)   /* then was originally first */
          Ct->ct_first = hnd;  /* hnd->next still points to right place */
       else
          pnd->c_next = hnd; 
       tout(fmt(mesg("You are$not registered in '%s'.\n"),dest));
       }
   }
else
   tout(fmt(mesg("You are$not registered in '%s'.\n"),srce));
}
