/**************************************************************************
*    CoSy conferencing system, written by Alastair Mayer
*    
*    Copyright (C) 1984 University of Guelph
*
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program; if not, write to the Free Software
*    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*
***************************************************************************/

/*******************************************************
* COSY(tm) Computer-Based Conferencing System          *
* Copyright (C) 1983, 1984, University of Guelph       *
* Written by: Alastair J.W. Mayer                      *
*******************************************************/
rmv_tname(cp,tnm)  /* remove topicnode with name tnm from confnode cp */
struct cnode * cp;
char * tnm;
{
   struct tnode * tprev, * ttgt;

  if ((tprev = cp->first) == NULL)
     return(-1);
  if (strcmp(tnm,tprev->name) == 0) { /* its the 1st one */
     cp->first = tprev->next;
     if (cp->last == tprev)
        cp->last = tprev->next;
     cp->n_topics-- ;
     free(tprev);
     return(0);
     }
  while ((tprev->next != NULL) && strcmp(tprev->next->name,tnm))
     tprev = tprev->next;
  if (tprev->next == NULL)  /* not found */
     return(-1);
  /*  found it, now get rid of it */
  if (cp->last == tprev->next)
     cp->last = tprev;
  ttgt = tprev->next;
  tprev->next = ttgt->next;
  cp->n_topics-- ;
  free(ttgt);
  return(0);
}
