/**************************************************************************
*    CoSy conferencing system, written by Alastair Mayer
*    
*    Copyright (C) 1984 University of Guelph
*
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program; if not, write to the Free Software
*    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*
***************************************************************************/

# include   <errno.h>

/* Wait time between attempts to obtain the semaphore file ..... */
# define   LOCK_SLEEP      1
#define MAX_TRIES  15
/* Semaphore file - the existence of this file blocks other processes. */

/* LOCK - Locks the given process */
lock(conf)
char   *conf;      /* conference name */
{
char   lock_file [100];
   int      fd ;
   extern int      errno ;
   int trys = 0;
   int prtwait = NO;

#ifdef DEBUG
 printf("Locking '%s'\n",conf);
#endif
   while ( MAX_TRIES > (trys++) )
   {
      errno = 0 ;
      strcpy(lock_file, conf);
      strcat(lock_file, ".LOK");
      fd = creat( lock_file, 0400 ) ;
      switch ( errno )      /* Creation unsuccessful, why ? */
      {
         case 0 :      /* Creation successful */
            if (prtwait) puts("");
            close( fd ) ;
            return (0);
         case EPERM :      /* Protection forbids creation  */
         case EACCES :      /* Another process has the file */
         case ENFILE :      /* System file table is full */
         case ENOENT :      /* Creation failed */
         if (prtwait)
            printf(".");
         else {
            printf("Waiting for file.");
            prtwait = YES;
            }
         fflush(stdout);
            sleep( LOCK_SLEEP ) ;   /* So try again */
            continue ;
         case EMFILE :      /* Too many open files */
            panic( "lock - emfile" ) ;
            /* NOTREACHED */ ;
         default :      /* Unknown error code */
            panic( "Lock - creat" ) ;
            /* NOTREACHED */ ;
      }
   }
   /** if got here, unable to lock file (someone else using it) */
   return(-1);
}

/* UNLOCK */
unlock (conf)
char   *conf;      /* conference name */
{
char   lock_file   [100];
#ifdef DEBUG
  printf("Unlocking '%s'\n",conf);
#endif
   strcpy(lock_file, conf);
   strcat(lock_file, ".LOK");
   unlink( lock_file ) ;
}

