/**************************************************************************
*    CoSy conferencing system, written by Alastair Mayer
*    
*    Copyright (C) 1984 University of Guelph
*
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program; if not, write to the Free Software
*    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*
***************************************************************************/

/*******************************************************
* COSY(tm) Computer-Based Conferencing System          *
* Copyright (C) 1983, 1984, 1985, University of Guelph *
* Written by: Alastair J.W. Mayer                      *
*******************************************************/
mailman(wd) /* do POST OFFICE functions */
char *wd;
{
  int key; char word[NMSIZE];
  int val;
#ifdef DEBUG
  puts("POST OFFICE entered.");
#endif

  strcpy(word,wd);
  if (word[0]=='\0')
     scan(word);
  key=lookup(word,MAIL_SS);
  switch (key) {
     case HELP_K:
        helper("converse");
        break;
     case NEW_K:
#ifdef BIX
        if (! no_priv(10)) send_mail();
#else
        if (! no_priv(2)) send_mail();
#endif
        break;
     case STAT_K:
        show_mail();
        break;
     case REPLY_K:
     if (no_priv(1)) break;
        if (add_msg()==0)
           cc_to();
        break;
     case DEL_K:
        mail_del();
        break;
     case NULL_K:
        break;
     case AMBIG_K:
        error(AMBKEY);
        lstambig(word,MAIL_SS);
        break;
     case QUIT_K:
        quit_conf();
        Subsys = MAIN_SS;
        break;
     case NUMBER_K:
        sscanf(word,"%d",&val);
        if (val>1000)
           join_conf(word,"");
     else if (confnode == NULL)
        puts(mesg("Not joined@to a conversation."));
        else
           rd_messages(val);
        Subsys = MAIL_SS;
        break;
     case WTHD_K:
        m_withdraw();
        break;
     default:
        if (lookup(word,READ_SS) != ERR_K) {
           reader(word);   /* if read command */
           Subsys = MAIL_SS;
           }
        else if (StrCmp(word,"send")==0) {
        printf("Use NEW to create a new conversation.\n");
           }
        else if (StrCmp(word,"leave")==0) {
           quit_conf();
           }
        else if (StrCmp(word,"pending")==0) {
           pending();
           }
        else {
           error(BADKEY);
           lstambig("",MAIL_SS);
           break;
           }
    }
}
 
check_mail()   /* see if any mail */
{
  if (Mt->ct_first != NULL) {
     printf("You have conv. msgs.\n");
     return(YES);
     }
  return(NO);
}
 
show_mail()  /* full mail status display */
{
        if (Mt->ct_first == NULL) {
           fputs(mesg("You have$no conv. msgs.\n"),Out);
           }
        else {
   /*
    *      incoming();
    *      outgoing();
    */
           pending();
           }
}
 
incoming()   /* list incoming messages (unread) */
{

#ifdef OLDMAIL
  puts(mesg("In-Basket display unavailable until further notice"));
#else
  cp = Mt->ct_first;
  if (cp == NULL) {
    fputs(mesg("You have$no conv. msgs.\n"),Out);
    return;
    }
  fputs(mesg("|In-Basket"),Out); fflush(Out);
  sys = Subsys;
  while (cp != NULL) {
     ml_hdr2(cp,&hrf);
     cp = cp->c_next;
     }
  quit_conf();
  Subsys = sys;
  if (hrf) fputs(mesg("| is empty.\n"),Out);
#endif
}
 
pending()   /* old mail list routine */
{
  struct cnode *cp;
   int phd = 1;

  cp = Mt->ct_first;
  if (cp == NULL) {
    fputs(mesg("You have$no conv. msgs.\n"),Out);
    return;
    }
/*
 * fputs(mesg("|Hold-Basket"),Out); fflush(Out);
 */
  while (cp != NULL) {
     ml_hdr(cp,&phd);
     cp = cp->c_next;
  }
  if (phd) fputs(mesg("| is empty.\n"),Out);
}
ml_hdr(cp,ph)    /* list mail header */
struct cnode *cp;
int *ph;
{
  FILE *fp, *fopen();
  long int mtime, mod_time();
  char *ct, *ctime();
  char name[NMSIZE];

#ifdef DEBUG
  printf(" in ML_HDR, mail no = %s\n",cp->c_name);
#endif
  if ((fp=fopen(mkpath(HDR,cp->c_name,""),"r")) == NULL)
     return /* (1) */ ;
  else {
     if (*ph) {
#if UNIX_IDS
        tout("Orig.    Conv#  New  Last Mod Date\n");
#else
        tout("Originator     Conv#  New  Last Mod Date\n");
#endif
        *ph = 0;
        }
     fscanf(fp,"%14s",name);
     mtime=mod_time(mkpath(TXT,cp->c_name,"message"));
#ifdef UTS
     ct=ctime(mtime);
#else
     ct = ctime(&mtime);
#endif
     if (Terse) {
        ct[16] = '\n';
        ct[17] = '\0';
        }
#ifdef UNIX_IDS
     tout(fmt("%-8s %s  %2d  %s",name,cp->c_name,new_msgs(cp,cp->first),ct));
#else
     tout(fmt("%-14s %s  %2d  %s",name,cp->c_name,new_msgs(cp,cp->first),ct));
#endif
     fclose(fp);
     }
}
 
mail_del()      /* delete mail  (withdraw from mail conf) */
 {
 char cname[NMSIZE];
 struct cnode *cp, *cfind();
#ifdef DEBUG
 puts(" DELeting conv");
#endif
 scan(cname);
 if (strlen(cname)==0) strcpy(cname,confname);
 if (strlen(cname)==0) {
    getlin(0,mesg("Conversation number?"));
    scan(cname);
    }
 quit_conf();
 if ((cp=cfind(cname)) == NULL) {
    printf("%s%s.\n",mesg("No conv. #|You have no conv. number "),cname);
    return;
    }
 else {
    printf("%s %s.\n",mesg("Deleting@conv. number"),cname);
    free_tlist(cp->first);
    rm_mnode(cp);
    filter(mkpath(MEMBR,cname,""),username);
    }
}

rm_mnode(cp)  /* remove cp from current mail list */
struct cnode *cp;
{
   struct cnode *sp;

   if (cp != NULL && (sp = Mt->ct_first) != NULL) {
      if (Mt->ct_first == cp) {
         if (Mt->ct_first == Mt->ct_last)
            Mt->ct_last = NULL;
         Mt->ct_first = cp->c_next;
         free(cp);
         }
      else {
         while (sp->c_next != cp && sp->c_next != NULL)
            sp = sp->c_next;
         sp->c_next = cp->c_next;
         if (Mt->ct_last == cp)
            Mt->ct_last = sp;
         free(cp);
         }
      }
}
m_withdraw()    /* kill mail conf */
{
  FILE *fmp, *fopen();
  char mbr[NMSIZE], mnum[NMSIZE];
  struct cnode *cp, *cfind();

  scan(mnum);
  if (lookup(mnum,MAIL_SS) != NUMBER_K) {
     puts(mesg("Format is 'WITHDRAW ####' where '####' is a number."));
     return;
     }
  if (is_mod(username,mnum)>=0) {
     if ((fmp = fopen(mkpath(MEMBR,mnum,""),"r")) != NULL) {
        puts(mesg("Removing other members."));
        while (fscanf(fmp,"%14s",mbr) != EOF) {
           remov_conf(mbr,mnum);
           }
        fclose(fmp);
        unlink(mkpath(MEMBR,mnum,""));
        }
      printf("%s %s.\n",mesg("Deleting@conv. number"),mnum);
      cp=cfind(mnum);
      if (cp != NULL) {
         free_tlist(cp->first);
         rm_mnode(cp);
         }
      }
  else
     printf(mesg("You did not originate conv. number %s.\n"),mnum);
}
 
cc_to()   /* check if need to add addressees to item */
{
FILE *fp, *fopen();

   puts(mesg("Current recipient list:"));
   list_part("");
   if (yorn(mesg("Do you wish to$add recipients"),'N')) {
      if ((fp = fopen(mkpath(MEMBR,confname,""),"a")) == NULL)
         puts(mesg("Can't add recipients."));
      else {
         puts(mesg("Enter list@of additional recipient names "));
         rgst_users(confnode,fp);
         fclose(fp);
         }
      }
}
