/**************************************************************************
*    CoSy conferencing system, written by Alastair Mayer
*    
*    Copyright (C) 1984 University of Guelph
*
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program; if not, write to the Free Software
*    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*
***************************************************************************/

/*******************************************************
* COSY(tm) Computer-Based Conferencing System          *
* Written by: Alastair J.W. Mayer                      *
*******************************************************/
h_replace(i,str)  /* replace hdr field i with string str */
int i;
char *str;
{
    char *strsave();

    if (hdrinfo[i] != NULL)
        free(hdrinfo[i]);
    hdrinfo[i] = strsave(str);
}

h_append(i,str)  /* add str to hdr field i */
int i;
char *str;
{
    char newstr[256];
    char *sep = ",\n ";
    char *strsave();
    char *fmt();

    if (hdrinfo[i] == NULL || strlen(hdrinfo[i]) == 0)
        hdrinfo[i] = strsave(str);
    else {
        if ((256-3) <= (strlen(str) + strlen(hdrinfo[i]))) {
           tout(fmt("Buffer full, can't add '%s'\n",str));
           flush();
           return;
           }
        strcpy(newstr,hdrinfo[i]);
        strcat(newstr,sep);
        strcat(newstr,str);
        free(hdrinfo[i]);
        hdrinfo[i] = strsave(newstr);
       }
}

h_getindx(str)   /* find index of field named str */
char *str;
{
    register int i;
    register char **hfld;

    hfld = hdrflds;
    for (i=0; strcmp(str,*hfld) && i<30 ; i++, hfld++);
    if (i<MAXHDR)
       return(i);
    else {
       printf("not found '%s'\n",str);
       return(-1);
       }
}

put_hdr(fp)   /* print header info on file fp */
FILE *fp;
{
    char fldname[30];
    int i;

    for (i=0; i<30; i++) 
       if (hdrinfo[i] != NULL) {
          strcpy(fldname,hdrflds[i]);
          chcase(fldname);
          fprintf(fp,"%s: %s\n",fldname,hdrinfo[i]);
          }
}

chcase(str)  /* upcase 1st letter of str, and any following '-' */
char *str;
{
     int wasdash = 0;

     *str = toupper(*str);
     while ((* ++str) != '\0') {
        if (wasdash)
           *str = toupper(*str);
        wasdash = (*str == '-');
        }
}
chkhdr()
{   register int i;

    for (i=0;i<30;i++) {
      printf("%s: %s\n",hdrflds[i],hdrinfo[i]);
      }
    fflush(stdout);
}

clr_hdr() /* clear out header fields for next msg */
{  
   register int i;

   for (i=0; i<MAXHDR; i++)
      if (hdrinfo[i] != NULL) {
         free(hdrinfo[i]);
         hdrinfo[i] = NULL;
         }
}
