/**************************************************************************
*    CoSy conferencing system, written by Alastair Mayer
*    
*    Copyright (C) 1984 University of Guelph
*
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program; if not, write to the Free Software
*    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*
***************************************************************************/

/*******************************************************
* COSY(tm) Computer-Based Conferencing System          *
* Written by: Alastair J.W. Mayer                      *
*******************************************************/
#include <errno.h>
#ifndef errno
extern int errno;
#endif

dcat(fi,fo,fp,vbose)  /* copy fi to fo until EOF or '.' */
FILE *fi, *fo, *fp;
int vbose;
{
#ifndef NL
#define NL '\n'
#endif
#define CHEOF  (char)EOF
#define DOT '.'
    register char c1,c2,c3;
    char *prompt = ">";

    if (vbose) {
       fprintf(fp,prompt);
       fflush(fp);
       }
    if ((c1 = fgetc(fi)) == CHEOF) return;
    c2 = fgetc(fi);
    if (c1 == DOT && c2 == NL)
       return;
    while ((c3 = fgetc(fi)) != CHEOF) {
       fputc(c1,fo);
       if (c1 == NL && c2 == DOT && c3 == NL)
          break;
       c1 = c2;
       c2 = c3;
       if (c3 == NL) {
          fflush(fo);
          if (vbose) {
             fprintf(fp,prompt);
             fflush(fp);
             }
          }
       }
    if (c3 == CHEOF) {
       fputc(c1,fo);
       fputc(c2,fo);
       }
}

int fgetc(fp)   /* define our own fgetc to ignore interrupts */
FILE *fp;
{
    int c;

    errno = 0;
    do {
       c = getc(fp);
    } while (c == EOF && errno == EINTR);
    return c;
}
