/**************************************************************************
*    CoSy conferencing system, written by Alastair Mayer
*    
*    Copyright (C) 1984 University of Guelph
*
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program; if not, write to the Free Software
*    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*
***************************************************************************/

/*******************************************************
* COSY(tm) Computer-Based Conferencing System          *
* Written by: Alastair J.W. Mayer                      *
*******************************************************/
fwrd_msg(n,subj)  /* forward message number n */
int n;
char *subj;
{
  char word[NMSIZE];
  int cont = YES;
  int key;
  char *mk_addr(), *mk_from();
  int basklo;

  strcpy(subj,"");
  basklo = NextOut;
  if (eoln()) getlin(0,"Forward to:");
  get_addrs("resent-to",YES);
  h_replace(h_getindx("resent-from"),mk_from(username));
  while (cont) {
      getlin(0,"fwd/action:");
      scan(word);
      key = lookup(word,M_SD_SS) ;
      switch (key) {
      case TO_K:
          get_addrs("resent-to",NO);
          break;
      case CC_K:
          get_addrs("resent-cc",NO);
          break;
      case FROM_K:
          get_addrs("resent-from",YES);
          h_replace(h_getindx("resent-sender"),mk_from(username));
          break;
      case EDT_K:
          puts("May not edit forwarded message.");
          break;
      case SEND_K:
          resend(n,basklo,subj);
          cont = NO;
          break;
      case SUBJ_K:
          puts("May not change subject of forwarded msg");
          break;
      case QUIT_K:
          cont = NO;
          NextOut = basklo;
          break;
      case HELP_K:
          helper("mailfwd");
          break;
      case AMBIG_K:
          error(AMBKEY);
          lstambig(word,M_SD_SS);
          break;
      default:
          if (strcmp(word,"chk") == 0)
             chkhdr();
          else {
          error(BADKEY);
          lstambig("",M_SD_SS);
          }
          break;
      } /* end switch */
  }  /* end while */
  clr_hdr();
}
resend(oldnum,lo,subj)  /* finish header processing & forward memo file */
int oldnum,lo;
char *subj;
{
  char strg[80];
  char mname[NMSIZE];
  char mnum[10];
  time_t time();
  char *timestamp();
  FILE *fp, *fi, *fopen();
  int i;
  
  newmemono(mname);
  sprintf(strg,"<memo.%s@%s>",mname,HERE);
  h_replace(h_getindx("resent-message-id"),strg);
  h_replace(h_getindx("resent-date"),timestamp());
  strcpy(strg,MEMTMP);
  strcat(strg,"memo");
  strcat(strg,mname);
  fp = fopen(strg,"w");
  put_hdr(fp);
  sprintf(mnum,"%d",oldnum);
  strcpy(strg,mkpath(MEMSPOOL,mnum,""));
  fi = fopen(strg,"r");
  filecopy(fi,fp);
  fclose(fi);
  fclose(fp);
  /*** and pass the file to the post office ***/
  sprintf(strg,"memoman.3 %s &",mname);
  system(strg);
  for (i=lo; i<NextOut; i++) {
     strcpy(out_basket[i].fr_nm,username);
     out_basket[i].nmbr = atoi(mname);
     out_basket[i].sent = time(0);
     updt_bask(out_basket[i].to_nm,username,out_basket[i].nmbr,OUT,subj);
     }
  printf("Memo %d forwarded as %s\n",oldnum,mname);
}
