/**************************************************************************
*    CoSy conferencing system, written by Alastair Mayer
*    
*    Copyright (C) 1984 University of Guelph
*
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program; if not, write to the Free Software
*    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*
***************************************************************************/

/*******************************************************
* COSY(tm) Computer-Based Conferencing System          *
* Written by: Alastair J.W. Mayer                      *
*                                                      *
* Changed to version 3.1.2 by getting memo message     *
* file from /usr/tmp/memo<nnnn> and moving it to       *
* /usr/memo/spool/<nnnn>.  This saves a bit of time.   *
*      --- Alastair Mayer 31 Oct '85                   *
*******************************************************/
#include <stdio.h>
#include <sys/signal.h>
#define YES 1
#define NO 0
#define NMSIZE 20
#define IN 1
#define OUT 0

char *mkpath(int, char*, char*);
#include "memo.h"
#include "../defs3.h"
#include "../pathnames.h"
char * username = "MEMOMAN.\0xxxxxx";

char *strcat(), *strcpy();

main(argc,argv)  /* distribute mail */
int argc;
char *argv[];
{
    FILE *fp, *fm, *fopen();
    int i;
    char *here[50];
    int nhere = 0;
    int there = 0;
    char fname1[50];
    char fname[50];
    char *tmpf = "/tmp/MMXXXXXX";
    char fromwho[20];
    char word[40];
    char subj[40];
    int mnum;
    int rsnt = NO;
    char *index(), *mktemp();

    setpgrp();      /* do this to disassociate self from parents signals */
    strcpy(fname,mkpath(MEMSPOOL,argv[1],""));
    strcpy(fname1,MEMTMP);
    strcat(fname1,"memo");
    strcat(fname1,argv[1]);
    strcat(username,argv[1]);  /* so if cantlock, know which to resend */
    if (link(fname1,fname) != 0) {   /* emulate "mv" */
       perror("memoman: delivery problems, reason");
       exit(0);
       }
/*    unlink(fname1); */  /* - defer the unlink in case of problems */
    mnum = atoi(argv[1]);
    if ((fm = fopen(fname1,"r")) == NULL) {
       printf("No mail #%s\n",argv[1]);
       exit(0);
       }
/** copy header to tempfile so we can just work on header **/
    {
      register char c1, c2;
    fp = fopen(mktemp(tmpf),"w+");
    c1 = fgetc(fm);
    while ((c2 = fgetc(fm)) != '\n' || c1 !='\n') {
       fputc(c1,fp);
       c1 = c2;
       }
    fclose(fm);
    fputc(c1,fp);
    fflush(fp);
    rewind(fp);
    }
    while (fscanf(fp,"%s",word) != EOF) {
       if ((strcmp("Resent-To:",word)==0) && (!rsnt)) {
          rsnt = YES;
          there = 0;
          nhere = bldlst(fp,here,&there,0,YES);
          }
       if ((!rsnt)&&((strcmp("To:",word)==0) || (strcmp("Cc:",word)==0))) {
          nhere = bldlst(fp,here,&there,nhere,NO);
          }
       if (strcmp("From:",word)==0) {
          fscanf(fp,"%s",fromwho);
          if (index(fromwho,'@') != 0)
             *index(fromwho,'@') = '\0';
          }
       if (strcmp("Subject:",word)==0) {
          fscanf(fp,"%30[^\n]",subj);
          }
       }
#ifdef DEBUG
  puts("memoman: finished with header");
  fflush(stdout);
  puts("distributing to:");
  for (i=0; i<nhere; i++) puts(here[i]);
#endif
    for (i=0; i<nhere; i++) {
       FILE *fp;
       char fname[30];
       int pid;
#ifdef MAILFLAG
       sprintf(fname,"/tmp/CU/%s",here[i]);
       if((fp = fopen(fname,"r")) != NULL) {
	  fscanf(fp,"%d",&pid);
	  kill(pid,SIGUSR1);
	  fclose(fp);
       }
#endif
       updt_bask(here[i],fromwho,mnum,IN,subj);
       }
     if (there) {
       sprintf(word,"vmpunch -v mailer -f 'cosy mail' %s",fname);
       system(word);
       }
   fclose(fp);
   unlink(tmpf);
   unlink(fname1); /* now get rid of copy on /usr/tmp */
}

bldlst(fp,ici,ext,n,rsnt)  /* get list of local addressees */
FILE *fp;
char *ici[];
int *ext, n, rsnt;
{
    char addr[30];
    char name[20];
    int cont = 1;
    char *strsave();
    char c;

    while (cont) {
       fscanf(fp,"%s",addr);
       c = addr[strlen(addr)-1];
       if (c==':') {
          if (rsnt) break;
          if (strcmp("To:",addr)==0 || strcmp("Cc:",addr)==0)
             continue;
          else
             break;
          }
       if (c==',') addr[strlen(addr)-1] = '\0';
       if (strcmp(HERE,index(addr,'@')+1)==0) {
          cpyto(name,addr,'@');
          ici[n] = strsave(name);
          n++;
          }
       else
          *ext = 1;
       }
    return(n);
}

cpyto(sd,ss,c)  /* copy ss to sd until end or 'c' */
char *sd, *ss, c;
{
    char ch;
    while ((ch = *sd = *ss) != '\0' && ch != c) {
         ss++;
         sd++;
         }
    if (ch == c) *sd = '\0';
}
#include "updbask.c"
#include "stubs.c"
#include "strsave.c"
#include "tstamp.c"
/* #include "strindx.c" */
#include "../lock/lock.c"
#include "../lock/cantlock.c"
tout()
{}
#include "mkpath.c"
