/**************************************************************************
*    CoSy conferencing system, written by Alastair Mayer
*    
*    Copyright (C) 1984 University of Guelph
*
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program; if not, write to the Free Software
*    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*
***************************************************************************/

char *mkpath(key,n1,n2) /* make file-path name according to key */
int key;
char *n1, *n2;   /* optional arguments */
{
  static char fname[100];

#if (DEBUG>1)
 printf("  in MKPATH ");
#endif
  if (key == SYSTM) {
     StrCpy(SPATH,fname);
     return(fname);
     }
  if (c_key(key)) {
     StrCpy(CPATH,fname);
     if (key == CLIST) {
        StrCat("ConfList",fname);
        }
     else {
        StrCat(n1,fname);
        if (key != CNODE)  {
        StrCat("/",fname);
        if (key == HDR)
           StrCat("Header",fname);
        else if (key == MEMBR)
           StrCat("Members",fname);
        else if (key == WORKF)
           StrCat("Workfile",fname);
        else {
        StrCat(n2,fname);
        if (key != TNODE)  {
        switch (key) {
           case ABS:
              StrCat("/Abstract",fname);
              break;
           case DIR:
              StrCat("/Dir",fname);
              break;
           case TXT:
              StrCat("/Text",fname);
              break;
           default:
              return(NULL);
           }
         }}}
        }
     }
    else if (u_key(key)) {
     StrCpy(UPATH,fname);
     if (key == ULIST) {
        StrCat("UserList",fname);
        }
     else {
        /***** break down to subdirectorys for Sys V 1000 link limit ***/
          if (*n1 == '.') {        /* special */
             strcat(fname,",/");
             }
          else {
             strncat(fname,n1,1);
             strcat(fname,"/");
             }
        StrCat(n1,fname);
        if (key != UNODE) {
        switch (key) {
        case CONF:
           StrCat("/Confs",fname);
           break;
        case NUCONF:
           StrCat("/Newconfs",fname);
           break;
        case RES:
           StrCat("/Resume",fname);
           break;
        case PASSWD:
           StrCat("/Passwd",fname);
           break;
        case PROF:
           StrCat("/Profile",fname);
           break;
        case SCRATCH:
           StrCat("/SCRATCHPAD",fname);
           break;
        case NOTEF:
           StrCat("/Note",fname);
           break;
        case MEM_IN:
           StrCat("/Memo_in",fname);
           break;
        case MEM_OUT:
           StrCat("/Memo_out",fname);
           break;
        case MXADDR:
          StrCat("/ExtMailAddr",fname);
          break;
        default:
           return(NULL);
        }
        }
      }
      }
   else if (key ==  HDOC) {
      StrCpy(HPATH,fname);
      StrCat(n1,fname);
      }
   else if (key == MEMSPOOL) {
      strcpy(fname,MSPLPATH);
      strcat(fname,&n1[strlen(n1)-2]);
      strcat(fname,"/");
      strcat(fname,n1);
      }
   else if (key == MEM_TMP) {
      StrCpy(MTMPATH,fname);
      }
   else
      return(NULL);
#if (DEBUG>1)
  printf("  pathname = '%s'\n",fname);
#endif
   return(fname);
 }

u_key(k) /* return non-zero if k valid 'userpath' key) */
int k;
{
  return ((MIN_UK <= k) && (k <= MAX_UK));
}

c_key(k)
int k;
{
  return ((MIN_CK <= k) && (k <= MAX_CK));
}

makedir(s1,s2)  /* make dir with name s1s2 */
char *s1, *s2;
{
   char cmd[50];

   strcpy(cmd,"mkdir ");
   strcat(cmd,s1);
   strcat(cmd,s2);
   fflush(stdout);  /* 11/34 seems to need this befor 'system' */
   return (system(cmd));
}
StrCpy(s,t)  /* copy s to t */
char *s, *t;
{
   while (*t++ = *s++)
      ;
}

StrCat(s,t) /* catenate s to end of t */
char *s, *t;
{
   while (*t++ != '\0')
      ;
   *t--;
   while (*t++ = *s++)
      ;
}
