/**************************************************************************
*    CoSy conferencing system, written by Alastair Mayer
*    
*    Copyright (C) 1984 University of Guelph
*
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program; if not, write to the Free Software
*    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*
***************************************************************************/

/*******************************************************
* COSY(tm) Computer-Based Conferencing System          *
* (MEMO Mail Subsystem)                                *
* Copyright (C) 1984, 1985, University of Guelph       *
* Written by: Alastair J.W. Mayer                      *
* Modified to improve speed & reliability by using     *
* link(2) instead of copy.  -- AJWM 31 Oct '85         *
* Further modified to increase robustness by changing  *
* order of data movement, file renaming -AM 21 Jan '86 *
*******************************************************/

#include <errno.h>
#ifndef errno
extern int errno;
#endif
#ifdef UNIX_IDS
#define RCOL 15
#else
#define RCOL 21
#endif

mrk_or_del(from,n,del) /* mark msg as read or delete it (out bask) */
char *from;
int n, del;
{
   char bask[BSKSIZ];
   char fname[50], tmpnm[50];
   FILE *f1, *f2, *fopen();
   int numb;
   int ownoutbask = NO;
   char tonm[NMSIZE];
   struct passwd *getpwnam();
   char *mktemp();
   char ch;

   if (strcmp(from,username)==0) ownoutbask = YES;
outbask:
   if (ishere(from)) {  /* check if user on system */
     strcpy(fname,mkpath(MEM_OUT,from,""));
     strcpy(tmpnm,fname);
     strcat(tmpnm,".NXT"); /* will cp Memo_out to Memo_out.NXT */
    /*** - C R I T I C A L - ***/
    if (lock(fname)) {
       cantlock(fname);
       goto inbask;
       }
#ifdef OLDCODE
     if (link(fname,tmpnm) != 0) {
        if (errno != ENOENT)   /* can ignore this one */
           perror("cosy: mrk_or_del");
        unlock(fname);
        goto inbask;
        }
    unlink(fname);
    fflush(stdout);
#endif OLDCODE
    if ((f1=fopen(fname,"r"))==NULL) {
       unlock(fname);
       printf("cosy: mrk_or_del: unable to update out_basket\n");
       fflush(stdout);
       fclose(f1);
       goto inbask;
       }
    if ((f2=fopen(tmpnm,"w"))==NULL) {
       unlock(fname);
       printf("cosy: mrk_or_del: unable to open out_basket\n");
       fflush(stdout);
       fclose(f1);
       goto inbask;
       }
    while (fread(bask,BSKSIZ,1,f1) > 0) {
        sscanf(bask,"%14s%d",tonm,&numb);
        if ((numb == n) && ((ownoutbask) || (strcmp(tonm,username)==0))) {
          bask[RCOL] = 'R';
          if (del) continue;   /* don't write */
          }
        fwrite(bask,BSKSIZ,1,f2);
        }
    fclose(f1);
    fclose(f2);
    /* new code - move NXT file to original */
    if (unlink(fname) == 0) {
       if (link(tmpnm,fname) == 0) {
          unlink(tmpnm);
          }
       }
    /** **/
    unlock(fname);
    /*** - end critical - ***/
#ifdef OLDCODE
    unlink(tmpnm);
#endif
    }  /* end of outbasket routine */
  /** ignore this next bit.  must have had a good
      reason for it once, but leaves stuff hanging
      around if you send to yourself
    if (ownoutbask)
       return; /* for DELETE command */

inbask:

    /* remove from own basket */
    strcpy(fname,mkpath(MEM_IN,username,""));
    strcpy(tmpnm,fname);
    strcat(tmpnm,".NXT");       /* mv Memo_in Memo_in.NXT */
    /*** - C R I T I C A L - ***/
    if (lock(fname)) {
       cantlock(fname);
       return;
       }
#ifdef OLDCODE
    if (link(fname,tmpnm) != 0) {
       if (errno != ENOENT)          /* how can we get this here? */
          perror("cosy: mrk_or_del");
       unlock(fname);
       return;
       }
    unlink(fname);        /** Very important to disconnect the link !! */
#endif
    if ((f1=fopen(fname,"r"))==NULL) {
       unlock(fname);
       printf("cosy: mrk_or_del: unable to update in_basket\n");
       fflush(stdout);
       return;
       }
    if ((f2=fopen(tmpnm,"w"))==NULL) {
       unlock(fname);
       printf("cosy: mrk_or_del: unable to open in_basket\n");
       fflush(stdout);
       fclose(f1);
       return;
       }
    while (fread(bask,BSKSIZ,1,f1) > 0) {
        sscanf(bask,"%14s%d",tonm,&numb);
#ifdef OLDCODE
        if ((numb == n) && strcmp(tonm,from) == 0) {
          bask[RCOL] = 'R';
          if (del) continue;   /* don't write */
          }
#else
        if (numb == n) {      /* allow to del from inbask, with verify */
           if (strcmp(tonm,from) && del) {
              tout(fmt("Del /%s/ ?",bask));
              ch = (bask[RCOL]=='R')?'Y':'N';
              if (yorn("",ch))
                 continue;
              }
           else {
              bask[RCOL] = 'R';
              if (del) continue;  /* dont write */
              }
           }
#endif
        fwrite(bask,BSKSIZ,1,f2);
        }
    fclose(f1);
    fclose(f2);
/* new stuf */
    if (unlink(fname)==0)
       if (link(tmpnm,fname)==0)
          unlink(tmpnm);
/* * */
    unlock(fname);
    /*** - end critical - ***/
#ifdef OLDCODE
    unlink(tmpnm);
#endif
}
