/**************************************************************************
*    CoSy conferencing system, written by Alastair Mayer
*    
*    Copyright (C) 1984 University of Guelph
*
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program; if not, write to the Free Software
*    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*
***************************************************************************/

/*******************************************************
* COSY(tm) Computer-Based Conferencing System          *
* Written by: Alastair J.W. Mayer                      *
*******************************************************/
/* memo read subsystem */

read_memo()
{
    int number, n;
    int delflag = NO;
    char word[NMSIZE];
    char fromwho[NMSIZE];
    int key;
    int i, cont;
    FILE *fp, *fopen();
    int found = NO;
    char fn[50];
    char sbj[40];
    int bnum, tgnum;   /* bask num, target num */

    strcpy(fn,mkpath(MEM_IN,username,""));
    LastIn = (filesize(fn)/BSKSIZ)-1;
    fflush(stdout);
    if (eoln())
       key = NULL_K;
    else {
        scan(word);
        key = lookup(word,MEMO_SS);
        }
    if (key == NULL_K) { /* read next */
       if (LastIn < 0) {
           puts("Nothing in In-Basket");
           return;
           }
        n = just_read + 1;
        if (n > LastIn) n = 0;
        if ((fp = fopen(fn,"r")) == NULL) {
           printf("Can't open In-basket.\n");
           return;
           }
/*
        if (fseek(fp,n*BSKSIZ,0)== -1)
           printf("Bad seek\n");
*/
        for (i=0;i<n;i++)
          if (fscanf(fp,"%*[^\n]%*c")==EOF) {
             printf("Bad seek\n");
             break;
             }
        fscanf(fp,"%14s%d",fromwho,&number);
#ifdef UNIX_IDS
        fscanf(fp,"%*26c%[^\n]",sbj);
#else
        fscanf(fp,"%*21c%[^\n]",sbj);
#endif
        fclose(fp);
        i = just_read = n;
        }
    else if (key == NUMBER_K) {
       tgnum = atoi(word);
       fp = fopen(fn,"r");
       found = NO;
       i = 0;
       if (fp != NULL) {
#ifdef UNIX_IDS
       while (fscanf(fp,"%14s%d%*26c%[^\n]",fromwho,&bnum,sbj) != EOF) {
#else
       while (fscanf(fp,"%14s%d%*21c%[^\n]",fromwho,&bnum,sbj) != EOF) {
#endif
          if (bnum == tgnum) {
             found = YES;
             break;
             }
          i++;
          }
       fclose(fp);
       }
       if ( ! found) {
            /* check the out_basket, too */
            strcpy(fn,mkpath(MEM_OUT,username,""));
            fp = fopen(fn,"r");
            if (fp != NULL) {
            while(fscanf(fp,"%*s%d%*[^\n]%*c",&bnum) != EOF)
                if (bnum == tgnum) {
                   found = YES;
                   break;
                   }
            fclose(fp);
            }
            if (found)
               dspla_msg(tgnum);
            else
               printf("No memo %s.\n",word);
            return;
            }
        number = bnum;
        just_read = i;
        }
    dspla_msg(number);
    delflag = NO;

    /* now we've read it, what do we do with it? */

    cont = YES;
    while (cont) {
        if (eoln())
            getlin(0,"read/action:");
        scan(word);
        key = lookup(word,M_RD_SS);
        switch (key) {
/** no more 'accept'
        case ACCEPT_K: 
**/
        case DEL_K:
                just_read-- ;
                delflag = YES;
        case LEAVE_K:
        case QUIT_K:
            mrk_or_del(fromwho,number,delflag);
            cont = NO;
            break;
        case REPLY_K:
            build_reply(fromwho,number,sbj);
            break;
        case FWRD_K:
            fwrd_msg(number,sbj);
            break;
        case ORIG_K:
             if (i=findorig(number))
                dspla_msg(i);
             else
                tout("This is not a reply.\n");
             break;
        case HELP_K:
             helper("mailread");
             break;
        case NULL_K:
        case AMBIG_K:
             error(AMBKEY);
             lstambig(word,M_RD_SS);
             break;
        default:
            if (StrCmp(word,"accept")==0 && strlen(word)>=3) {
               /* allow accept for them that know it */
               just_read--;
               delflag = YES;
               mrk_or_del(fromwho,number,delflag);
               cont = NO;
               break;
               }
            else if (strcmp(word,"copy")==0) {
                mlcopy(number);
                }
            else if (StrCmp(word,"comment")==0) {
               build_reply(fromwho,number,sbj);
               }
            else {
            error(BADKEY);
            lstambig("",M_RD_SS);
            break;
               }
        }
    }
}
