/**************************************************************************
*    CoSy conferencing system, written by Alastair Mayer
*    
*    Copyright (C) 1984 University of Guelph
*
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program; if not, write to the Free Software
*    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*
***************************************************************************/

/*******************************************************
* COSY(tm) Computer-Based Conferencing System          *
*   MEMO Mail Subsystem                                *
* Written by: Alastair J.W. Mayer                      *
*******************************************************/
/* new and improved send functions */

send_memo(rply,subj,n)  /* format & send a memo file */
int rply;  /* is this a reply? */
char *subj;
int n;  /* if it is a reply, then this is what is replying to */
{
  char word[NMSIZE];
  int cont = YES;
  int key;
  char *mk_addr(), *mk_from();
   int basklo;
  FILE *fo, *fopen();

  if ( ! rply) {
      basklo = NextOut;
      if (eoln()) getlin(0,"To:");
      get_addrs("to",YES);
      getlin(0,"Enter subject: ");
      h_replace(h_getindx("subject"),&line.txt[line.ptr]);
      sprintf(subj,"%-30s",&line.txt[line.ptr]);
      flush();
      }
  else
     basklo = NextOut-1;
  h_replace(h_getindx("from"),mk_from(username));
  fill_scratch( (strcmp(ED_V,Editor)==0),NO);
 if (rply) 
    if (yorn("Attach original message ",'N')) {
       FILE *fi;
       char mnum[10];
       fo = fopen(mkpath(SCRATCH,username,""),"a");
       sprintf(mnum,"%d",n);
       fi = fopen(mkpath(MEMSPOOL,mnum,""),"r");
       fprintf(fo,"\n-------- Original Message --------\n\n");
       filecopy(fi,fo);
       fclose(fi);
       fclose(fo);
       }
  while (cont) {
      if (eoln())
         getlin(0,"send/action:");
      scan(word);
      key = lookup(word,M_SD_SS) ;
      switch (key) {
      case TO_K:
          get_addrs("to",NO);
          break;
      case CC_K:
          get_addrs("cc",NO);
          break;
      case FROM_K:
          tout("Sorry, FROM de-imlemented.\n");
          break;
/******
          get_addrs("from",YES);
          h_replace(h_getindx("sender"),mk_from(username));
          break;
*******/
      case EDT_K:
          editmsg("SCRATCHPAD",SCRATCH);
          break;
      case SEND_K:
          wrapup(basklo,subj);
          cont = NO;
          break;
      case SUBJ_K:
          if (eoln())
             getlin(0,"Enter subject: ");
          h_replace(h_getindx("subject"),&line.txt[line.ptr]);
          sprintf(subj,"%-30s",&line.txt[line.ptr]);
          flush();
          break;
      case CLEAR_K:
           fclose(fopen(Scratchpad,"w"));
      case QUIT_K:
          cont = NO;
          NextOut = basklo;
          break;
      case LIST_K:
          flist(Scratchpad);
          break;
      case HELP_K:
          helper("mailsend");
          break;
      case AMBIG_K:
          error(AMBKEY);
          lstambig(word,M_SD_SS);
          break;
      default:
          if (strcmp(word,"chk") == 0){
             chkhdr();
             put_hdr(stdout);
             }
          else {
          error(BADKEY);
          lstambig("",M_SD_SS);
          }
          break;
      }  /* end switch */
   } /* end while */
   clr_hdr();
   strcpy(subj,"");
}

pscan(prompt,buf)  /* scan, if EOL then issue prompt & rescan */
char *prompt, *buf;
{
   register int cont;

  cont = eoln();
 if (cont)
  while (cont) {
      getlin(0,prompt);
     cont = ((scan(buf) == NULL) && eoln());
     }
 else
    scan(buf);
}

char * mk_addr(local,host)  /* make address of form <local>@<host> */
char *local, *host;
{
   static char buf[50];

   strcpy(buf,local);
   strcat(buf,"@");
   strcat(buf,host);
   return(buf);
}

char *mk_from(uname)  /* make fudged address field for 'From' */
char *uname;
{
   /* since we're not considered a separate destination to RSCS,
      we have to fudge things to get 'mailer' to cooperate.
   */

   static char addr[100];

   strcpy(addr,uname);
/*
   strcat(addr," on COSY < UTS @ UOGUELPH >");
*/
   /** changed -- Byte system **/
   strcat(addr,"@");
   strcat(addr,HERE);
   return(addr);
}
get_addrs(field,rep)  /* get 1 or more addresses and append or replace field */
char *field;
int rep;  /* TRUE for replace */
{
   char name[NMSIZE], local[NMSIZE], host[NMSIZE];
   int indx;
   int first = YES;
   int tofield;
   char *mk_addr();
   struct passwd *getpwnam();

   tofield = (strcmp(field,"to")==0 || strcmp(field,"cc")==0);
   indx = h_getindx(field);
   pscan("Name(s)?",name);
   while (strlen(name) > 0) {
      strcpy(local,name);
      if ((scan(name) != NULL)  &&
         ((strcmp(name,"@")==0) || (strcmp(name,"at")==0)))
            scan(host);
      else
         strcpy(host,HERE);
      if (strcmp(host,HERE)==0 && (! ishere(local))) {
         printf("No user '%s' on COSY - ignored.\n",local);
         }
      else {
         if (tofield && strcmp(host,HERE)==0) {
            strcpy(out_basket[NextOut++].to_nm,local);
            }
         if (first && rep)  {
            h_replace(indx,mk_addr(local,host));
            first = NO;
            }
         else
            h_append(indx,mk_addr(local,host));
      }
#ifdef UTS
      if (strcmp(host,HERE) != 0)   /* off-system address, mung sender field */
         h_replace(h_getindx("sender"),"UTS@UOGVMB");
#endif
      if (strcmp(name,"@")==0 || strcmp(name,"at")==0) /* never got next name */
            scan(name);
      }
   }

wrapup(lo,subj)  /* finish header processing & send memo file */
int lo;
char *subj;
{
  char strg[80];
  char mname[NMSIZE];
  time_t tnow, time();
  char *timestamp();
  FILE *fp, *fi, *fopen();
  int mnum;
  int i;
  
  newmemono(mname);
  sprintf(strg,"<memo.%s@%s>",mname,HERE);
  h_replace(h_getindx("message-id"),strg);
  h_replace(h_getindx("date"),timestamp());
  /*******  change to put in /usr/tmp file, let memoman mv it *****/
  strcpy(strg,MEMTMP);
  strcat(strg,"memo");
  strcat(strg,mname);
  /***/
  if ((fp = fopen(strg,"w")) == NULL) {
     puts("Can't open mail spool file. Not sent.");
     return;
     }
  put_hdr(fp);
  fputs("\n",fp);
  if ((fi = fopen(Scratchpad,"r")) == NULL) {
     puts("Can't access scratchpad. Not sent.");
     fclose(fp);
     return;
     }
  tout("Sending.."); fflush(Out);
  filecopy(fi,fp);
  fclose(fi);
  fclose(fp);
  /* memo file created, now erase scratchpad */
  unlink(Scratchpad);
  /*** and pass the file to the post office ***/
  sprintf(strg,"memoman.3 %s &",mname);
  system(strg);
  mnum = atoi(mname);
  tnow = time(0);
  for (i=lo; i<NextOut; i++) {
     strcpy(out_basket[i].fr_nm,username);
     out_basket[i].nmbr = mnum;
     out_basket[i].sent = tnow;
     updt_bask(out_basket[i].to_nm,username,out_basket[i].nmbr,OUT,subj);
     }
  tout(fmt("Memo %s sent\n",mname));
}

#ifdef SYS_V
#include <unistd.h>
#endif

newmemono(cp)  /* get new memo number */
char *cp;
{
   int mno;
   FILE *fp, *fopen();
   char *fn = "/cosy/Memonext";
#define LSIZE 100L

/*** CRITICAL ***/
#ifndef SYS_V            /* lets try kernel locking */
   if (lock(fn)) {
      cantlock(fn);
      return;
      }
#endif
   if ((fp = fopen(fn,"r+")) == NULL) {
      tout("panic: can't get next memo #");
#ifndef SYS_V
      unlock(fn);
#endif
      return;
      }
   else {
#ifdef SYS_V    /* here's the locking */
      lockf(fileno(fp), F_LOCK, LSIZE);     /* 100 should be enough - is smallfile*/
#endif
      fscanf(fp,"%d",&mno);
      mno++;
      rewind(fp);
      sprintf(cp,"%d",mno);
      fprintf(fp,"%s \n",cp);
      fflush(fp);
#ifndef SYS_V
      fclose(fp);
#endif
      }
#ifdef SYS_V
   rewind(fp);
   lockf(fileno(fp), F_ULOCK, LSIZE);
   fclose(fp);
#else
   unlock(fn);
#endif
/*** END CRITICAL ***/
}
