/**************************************************************************
*    CoSy conferencing system, written by Alastair Mayer
*    
*    Copyright (C) 1984 University of Guelph
*
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program; if not, write to the Free Software
*    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*
***************************************************************************/

/*******************************************************
* COSY(tm) Computer-Based Conferencing System          *
*  MEMO mail subsystem                                 *
* Copyright (C) 1984, 1985, University of Guelph       *
* Written by: Alastair J.W. Mayer                      *
*******************************************************/
/*
 * Create a char time stamp according to ARPA RFC 822 standard,
 * ie [day,] dd mmm yy hh:mm:ss zzz   eg "Thu, 28 Jun 84 13:27:45 EDT"
 *
 *  Author: Alastair Mayer
 */

#ifdef BSD4
#ifndef SYS_TYPES
#include <sys/types.h>
#define SYS_TYPES 1
#endif
#include <sys/time.h>
#else
#include <time.h>
#endif /* BSD4 */

#define EST 5*60
char * timestamp()   /* create an RFC-822 std time stamp */
{
   char * ctime();
   char * rfctime();
   time_t tym;
   tym = time(0);
   return(rfctime(&tym));
}

char *rfctime(tym)   /* return char string from tym */
time_t *tym;
{
   struct tm * localtime();
#if 0
/* LINUX uses tzname */
#ifndef SYS_V
   char * timezone();
#else
   /* system V uses external tzname[] for the same thing */
#endif
#endif

   struct tm * timenow;
   static char tstamp[30];
   char *tmstr;
#ifdef UTS
   tmstr = ctime( *tym );
   timenow = localtime( *tym );
#else
   tmstr = ctime( tym );
   timenow = localtime( tym );
#endif
   strncpy(tstamp,tmstr,3);    /* day */
   strcat(tstamp,", ");
   tstamp[5] = tmstr[8];
   tstamp[6] = tmstr[9];     /* dd  */
   tstamp[7] = 0;
   strncat(tstamp, tmstr+3, 5);  /* mth */
   tstamp[12] = tmstr[22];
   tstamp[13] = tmstr[23];    /* yy */
   tstamp[14] = 0;
   strncat(tstamp, tmstr+10,10);  /* hh:mm:ss */
#if 0
#ifdef SYS_V
   strcat(tstamp, tzname[timenow->tm_isdst]);
#else
   strcat(tstamp, timezone(EST, timenow->tm_isdst));
#endif
#else
/* LINUX uses tzname[] */
   strcat(tstamp, tzname[timenow->tm_isdst]);
#endif
   return(tstamp);
}
