/**************************************************************************
*    CoSy conferencing system, written by Alastair Mayer
*    
*    Copyright (C) 1984 University of Guelph
*
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program; if not, write to the Free Software
*    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*
***************************************************************************/

/*******************************************************
* COSY(tm) Computer-Based Conferencing System          *
* Copyright (C) 1983, 1984, University of Guelph       *
* Written by: Alastair J.W. Mayer                      *
*******************************************************/
/*   prompts with suffix and gets a line from the user to see if answer was
*    y (returns 1), n (returns 0), .
*    If neither y nor n says "a yes or no was expected." and prompts again.
*    If cr is done, does default or prompts again.
*/

yorn(promptprefix,deflt)
char      *promptprefix ;
char deflt;
{
     char line[ BUFSIZ ] ;
     char *chp ;
     char wd[20];
     char *fgets() ;

     if (! eoln()) {    /* allow it on same line */
        scan(wd);
        if (*wd == 'y') return(1);
        if (*wd == 'n') return(0);
      /* else ignore & prompt */
        }
     while (1)
     {
          printf("%s (y/n)? %c\b", promptprefix,deflt) ;
          fgets( line, BUFSIZ, stdin ) ;
          for( chp = line ; *chp == '\t'|| *chp == ' '; chp++ ) ;
               if( *chp == '\0')
               {
                    fprintf( stderr, "Input line too long\n" );
                    exit( 1 ) ;
               }
          if (*chp == '\n') *chp = deflt;
          switch ( *chp ) {
          case 'n':
          case 'N':
               return( 0 ) ;
               break ;
          case 'y':
          case 'Y':
               return( 1 ) ;
          case ' ':
               continue ;
          default:
               printf("A 'yes' or 'no' was expected.\n" ) ;
               continue ;
          }
     }
}
 
