/**************************************************************************
*    CoSy conferencing system, written by Alastair Mayer
*    
*    Copyright (C) 1984 University of Guelph
*
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program; if not, write to the Free Software
*    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*
***************************************************************************/

/*******************************************************
* COSY(tm) Computer-Based Conferencing System          *
* Written by: Alastair J.W. Mayer                      *
*******************************************************/
filter(fn,s) /* filter line beginning with string s from file named fn */
char *fn, *s;
{
   FILE *fp, *fs, *fopen();
   char *mktemp(), fsn[20], t[25], ln[100];
   char *templat = "/tmp/CFXXXXXX";

#ifdef DEBUG
 printf(" filtering '%s' from '%s'\n",s,fn);
#endif
   if ((fp=fopen(fn,"r"))==NULL) {
      return(-1);
      }
   strcpy(fsn,templat);
   mktemp(fsn);
   if ((fs=fopen(fsn,"w+"))==NULL) {
      fclose(fp);
      return(-1);
      }
 /***** critical section *******/
   lock(fn);
   t[0] = ln[0] = '\0';
   while (fscanf(fp,"%24s%[^\n]",t,ln) != EOF) {
      if (strcmp(t,s))
         fprintf(fs,"%s%s\n",t,ln);
      t[0] = ln[0] = '\0';
      }
   fclose(fp);
   if ((fp=fopen(fn,"w"))==NULL) {
      puts("filter: unable to open file for write\n");
      unlock(fn);
      fclose(fs);
      return(-1);
      }
   rewind(fs);
   filecopy(fs,fp);
   fclose(fp);
   unlock(fn);
 /***** end critical section ******/
   fclose(fs);
   unlink(fsn);
   return(0);
 }
