/**************************************************************************
*    CoSy conferencing system, written by Alastair Mayer
*    
*    Copyright (C) 1984 University of Guelph
*
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program; if not, write to the Free Software
*    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*
***************************************************************************/

/*******************************************************
* COSY(tm) Computer-Based Conferencing System          *
* Written by: Alastair J.W. Mayer                      *
*******************************************************/
join_new()  /* join a new conf (i.e. create new) */
 {
 char cname[NMSIZE];
 char junk[5];
 char *mkpath();
 FILE *fp, *fopen();
 long clock,time();    /* used for creation date */
 int closed,confid;
 register int key;

#ifdef DEBUG
 puts(" JOINing a NEW conf (creating)");
#endif
 if (no_priv(3)) { flush(); return; }
 cname[0]='\0';
 scan(cname);
GETNAME:
 while (cname[0]=='\0') {
    getlin(0,"Conference name? ");
    scan(cname); 
    }
 if (strlen(cname) > (NMSIZE-1)) {
    cname[NMSIZE-1] = '\0';
    tout(fmt("Name too long, truncated to '%s'.\n",cname));
    }
 /* check restrictions on confname */
 if ((key=lookup(cname,ALL_SS)) != ERR_K || strlen(cname) == 1) {
    if (key == QUIT_K) return;
    tout(fmt("Sorry, you cannot use '%s'. Please choose another.\n",cname));
    *cname = 0;
    goto GETNAME;
    }
#if 0
 if (makedir(CPATH,cname)) /* oops */ return;
#else
 if (makedir(mkpath(CNODE,cname,""))) return;
#endif
 logger("MODNEW",cname);
 confid = NO;
 closed = yorn(mesg("Closed@conference"),' ');
 if (closed) confid = yorn(mesg("Confidential@(unlisted) conference?"),' ');
 if ( ! confid ) {
   fp = fopen(mkpath(CLIST),"a");
    fprintf(fp,"%c %-14s",((closed)?'c':'o'),cname);
    puts(mesg("Enter one line conference title."));
    getlin(0,"n:");
    fprintf(fp," %s\n",line.txt);
    fclose(fp);
    }
/* now create topic list */
 fp = fopen(mkpath(HDR,cname),"w");
#ifdef DEBUG
 printf("moderator=%s.\n",username);
#endif
 fprintf(fp," %s\n",username);
 clock=time(0);
 fprintf(fp,"%ld\n",clock);
 while (create_topics(fp,cname) < 1)
    tout(mesg("You must have at least one topic.\n"));
 fclose(fp);
 /* now register self */
 add_list(Ct,cname);
 joined_flag = ON;
 confnode = Ct->ct_last;;
 StrCpy(cname,confname);
 topicnode = confnode->first;
 if (topicnode != NULL)
    StrCpy(topicnode->name,topicname);
 /* and add initial users */
 if ((fp = fopen(mkpath(MEMBR,cname),"w")) == NULL)
    puts(mesg("Can't register members."));
 else {
    fprintf(fp,"%s \n",username); /* add self first */
    fclose(fp);
    tout(mesg("Use 'Add Participants' to add initial members.\n"));
    if (!Terse)
       tout(mesg("Use 'Show Who <name>' to find user nicknames.\n"));
    }
 }

rgst_users(cp,fp) /* add users to conf */
struct cnode *cp;
FILE *fp;
{
   char name[NMSIZE];

   if (eoln()) 
       getlin(0,"Name(s) to add: ");
   while (scan(name) != NULL) {
      if (add_member(name,cp))
         tout( fmt( clip("Unable to register '%s'.\n"), name));
      else {
         fprintf(fp,"%s\n",name);
         tout(fmt(clip("|'%s' added.\n"),name));
         }
        }
}

add_member(name,cp) /* add cp to user 'name's ConfList */
char *name;
struct cnode *cp;
{
   char *mkpath();
   FILE *fp, *fopen();
   long int filesize();

   if (filesize(mkpath(NOTEF,name)) > 1L) {
      printf(mesg("Note from '%s':\n"),name);
      flist(mkpath(NOTEF,name));
      }
   if ((fp = fopen(mkpath(NUCONF,name),"a")) == NULL)
      return(-1);
   fput_clst(fp,cp,YES);
   fclose(fp);
   return(0);
}

create_topics(hp,cname) /* add topics to a conference */
FILE *hp;
char cname[];
{
 char name[20], *fname, msg[80];
 char *mkpath();
 int key;
 long filesize();
 int nt; /* no of topics created */
 int i;

#ifdef DEBUG
 puts(" creating topics");
#endif

 nt = 0;
 tout(mesg("Enter the list of topics in the form:\n"));
 tout(mesg(" name   Description of Topic Name \n"));
 tout(mesg("Terminate with the word 'quit'.\n"));
 getlin(0,"n:");
 scan(name);
 name[14] = '\0';   /* make sure name is not too long */
 key=lookup(name,JOIN_SS);
 while (key != QUIT_K) {
    if (lookup(name,ALL_SS) != ERR_K)
       tout(fmt(mesg("Sorry, you cannot use '%s' as a topic name.\n"),name));
    else {
       fname = mkpath(TNODE,cname,name);
       if (filesize(fname) != -1L)
          printf(mesg("You've already used '%s'.\n"),name);
       else {
       makedir(fname,"");
       close(creat(mkpath(DIR,cname,name),0660));
       close(creat(mkpath(TXT,cname,name),0660));
          strcpy(msg,(line.txt+strlen(name)));
       for (i=0; msg[i]==' ' || msg[i] == '\t'; i++);
          fprintf(hp,"%-15s %s\n",name,&msg[i]);
          nt++;
          }
       }
    getlin(0,"n:");
    scan(name);
    key=lookup(name,JOIN_SS);
    }
  return(nt);
 }
