/**************************************************************************
*    CoSy conferencing system, written by Alastair Mayer
*    
*    Copyright (C) 1984 University of Guelph
*
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program; if not, write to the Free Software
*    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*
***************************************************************************/

/*******************************************************
* COSY(tm) Computer-Based Conferencing System          *
* Written by: Alastair J.W. Mayer                      *
*******************************************************/
m_chg_topic()  /* change a topic name/description */
{
   struct tnode *mk_tnode(), *tfind();
   struct cnode *cnalloc();
   char *strsave();
   struct tnode *tp1, *tp2;
   struct cnode *cp1, *cp2;
   char onam[15],nunam[15],unam[15],name1[15],name2[15];
   char cmd[120], nupath[50];
   char txpath[50];
   FILE *fp, *fopen();

   while (scan(onam)==NULL)
      getlin(0,"Topic to change? ");
   while (scan(nunam)==NULL)
      getlin(0,"Change to: ");
   if (tfind(onam,confnode) == NULL) {
      tout(fmt("No such topic '%s'\n",onam));
      return(-1);
      }
   getlin(0,"New topic description: ");
   /********************** C R I T I C A L ***************/
   /* we lock the MEMBER file so nobody new registers while we're playing */
   lock(mkpath(MEMBR,confname,""));
   filter(mkpath(HDR,confname,""),onam);  /* get rid of the old */
   fp = fopen(mkpath(HDR,confname,""),"a");
   fprintf(fp,"%s	%s\n",nunam,line.txt);  /* and add the new */
   flush();  /* get rid of input line */
   fclose(fp);
   strcpy(nupath,mkpath(TNODE,confname,nunam)); /* for subsequent use */
   makedir(nupath,"");  /* make the dir */
   strcpy(txpath,mkpath(TXT,confname,onam));
   sprintf(cmd,"ln %s %s ; ln %s %s ",txpath,nupath,
                mkpath(DIR,confname,onam), nupath);
   system(cmd);  /* make links for actual text */
   tout("Updating.\n");
   /* now make dummy nodes for deferred processing */
   cp1 = cnalloc();
   tp1 = mk_tnode(nunam,0,0);
   name1[0] = '+'; strcpy(&name1[1],confname);
   cp1->c_name = name1;
   cp1->c_next = NULL;
   cp1->n_topics = 1; cp1->first = cp1->last = tp1;
   cp2 = cnalloc();
   tp2 = mk_tnode(onam,0,0);
   name2[0] = '-'; strcpy(&name2[1],confname);
   cp2->c_name = name2;
   cp2->c_next = NULL;
   cp2->n_topics = 1; cp2->first = cp2->last = tp2;
   /* now update the members' lists */
   fp = fopen(mkpath(MEMBR,confname,""),"r");
   while (fscanf(fp,"%s",unam) != EOF)
      if (strcmp(unam,username)) {  /* skip moderator */
         add_member(unam,cp1);
         add_member(unam,cp2);
         }
   fclose(fp);
   unlock(mkpath(MEMBR,confname,""));  /* nearly done, we can release this */
  /************** E N D   C R I T I C A L *****************/
   free(tp1); free(tp2);
   tp1 = tfind(onam,confnode);
   free(tp1->name);
   tp1->name = strsave(nunam);
   /* that bit of jiggery-pokery changes the topicname in the moderators
    * in-core list without leaving unpointed-to bits of memory around */
   free(cp1); free(cp2);
   return(0);
}
