/**************************************************************************
*    CoSy conferencing system, written by Alastair Mayer
*    
*    Copyright (C) 1984 University of Guelph
*
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program; if not, write to the Free Software
*    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*
***************************************************************************/

/*******************************************************
* COSY(tm) Computer-Based Conferencing System          *
* Written by: Alastair J.W. Mayer                      *
*******************************************************/
modparse(wd)  /* parser for 'modify' subsystem */
char *wd;
   {
   int key, k;
   int cont = 1;
   char word[NMSIZE];
   FILE *fopen();
   char *mkpath();

#ifdef DEBUG
  printf("-modparser entered\n");
#endif
 Subsys = MOD_SS;
 unscan(wd);
 while (cont) {
   if (eoln())
      getlin(0,"Mod:");
   Out = stdout;
   while (cont && 0==eoln())
      {
      scan(word);
      key=lookup(word,MOD_SS);
      switch (key)
         {
         case HELP_K:
            helper("moderate");
            break;
         case NEW_K:
#ifdef BIX
         /* conf. creation needs higher priv. on BIX */
         if (no_priv(4)) break;
#else
         if (no_priv(3)) break;
#endif
            join_new();
            break;
         case ADD_K:
            mod_adder();
            break;
         case REM_K:
            mod_remover();
            break;
         case TERM_K:
            mod_terminate();
            break;
         case TOPIC_K:
            mod_q_topic();
            break;
         case PARTICIP_K:
            mod_q_part();
            break;
         case QUIT_K:
            cont = NO;
            break;
        case DEL_K:  /* delete (withdraw?) a message */
            { int lpcnt = 5;
              char tnam[NMSIZE];
              char mnum[NMSIZE];

              mnum[0] = tnam[0] = '\0';
              scan(tnam);
              if (numeric(tnam))
                  strcpy(mnum,tnam);
              else
                  unscan(tnam);
              tnam[0] = '\0';
              while (lpcnt-- && get_topic(tnam)) {
                 tout(fmt("Topic '%s' not found.\n",tnam));
                 tnam[0] = '\0';
                 }
              if (lpcnt <=0) {
                 tout("Can't access topic.\n");
                 break;
                 }
              strcpy(topicname,tnam);
           if ((ftopic = fopen(mkpath(TXT,confname,topicname),"r"))==NULL ||
               (fmsgdir = fopen(mkpath(DIR,confname,topicname),"r"))==NULL) {
               tout("Can't access topic.\n");
               break;
               }
            unscan(mnum);
            r_withdraw((is_mod(username,confname)? 'S' : 'M'));
/******
    Now, remember to CLOSE ftopic and fmsgdir so open files don't accum.
    - AJWM Sept '85
******/
           if (ftopic != NULL) fclose(ftopic);
           if (fmsgdir != NULL) fclose(fmsgdir);
            break;
            }
         case NULL_K:
            break;
         case CHNG_K:
            m_chg_topic();
            break;
         case ERR_K:
            if ((k = lookup(word,MAIN_SS)) != ERR_K) {
               if (k==SHOW_K)
                  lister();
               else
                  puts(mesg("Command not recognized at this level, use QUIT first."));
               }
            else {
               error(BADKEY);
               lstambig("",MOD_SS);
               }
            break;
         case READ_K:   /* make a topic read-only */
             m_ronly();
             break;
         case AMBIG_K:
            error(AMBKEY);
            lstambig(word,MAIN_SS);
            break;
         default:
            error(BADKEY);
            break;
         }
       }
     }
   Subsys = MAIN_SS;
   quit_conf();
   }

mod_adder()   /* add a member or topic */
{
  char wd[NMSIZE];

#ifdef DEBUG
  puts(" in mod_adder ");
#endif

  scan(wd);
  switch (lookup(wd,MOD_SS)) {
     case TOPIC_K: m_add_topic(); break;
     case PARTICIP_K: m_add_membr(); break;
     case NULL_K: getlin(0,mesg("Add$topic or participant?"));
                  mod_adder();
                  break;
     default: puts(mesg("TOPIC or PARTICIPANT expected@after ADD."));
              break;
     }
}
mod_remover()   /* remov a member or topic */
{
  char wd[NMSIZE];

#ifdef DEBUG
  puts(" in mod_remover ");
#endif

  scan(wd);
  switch (lookup(wd,MOD_SS)) {
     case TOPIC_K: m_rmv_topic(""); break;
     case PARTICIP_K: m_rmv_membr(); break;
     case NULL_K: getlin(0,mesg("Remove$topic or participant?"));
                  mod_remover();
                  break;
     default: puts(mesg("TOPIC or PARTICIPANT expected@after REMOVE."));
              break;
     }
}
mod_q_topic()
 {
 puts(mesg("ADD or REMOVE expected@before TOPIC."));
 flush();
 }
  
mod_q_part()
 {
 puts(mesg("ADD or REMOVE expected@before PARTICIPANT."));
 flush();
 }
mod_terminate()
{
  char cmd[100], *mkpath();

  strcpy(cmd,"chmod -w ");
  strcat(cmd,mkpath(CNODE,confname));
  strcat(cmd,"/*/*");
  fflush(stdout);
  system(cmd);
  puts(mesg("Conference topics are now READONLY."));
}
 
m_add_topic()
 {
    FILE *fp, *fopen();
    char *mkpath();
    struct cnode *cp, *cnalloc();
    struct tnode *tp;
    char name[20], unam[NMSIZE];
    int nn, nt, i;

    fputs(mesg("Adding topics\n"),Out);
    if ((fp = fopen(mkpath(HDR,confname),"a"))==NULL) {
       puts(mesg("Can't add"));
       return;
       }
    nn = create_topics(fp,confname);
    fclose(fp);
    /* now remove and re-add moderator */
    free_tlist(confnode->first);
    rm_cnode(confnode);
    /* re join moderator */
    add_list(Ct,confname);
    confnode = Ct->ct_last;
    /* build dummy node for updates */
    nt = confnode->n_topics - nn; /* total - new */
    cp = confnode;
    tp = cp->first;
    for (i=1; i<=nt; i++)
      tp = tp->next;
    cp = cnalloc();  /* new node */
    name[0]='+'; strcpy(&name[1],confname);
    cp->c_name = name;
    cp->c_next = NULL;
    cp->n_topics = nn;
    cp->first = tp; cp->last = confnode->last;
    /* finally, update member conflist */
    puts(mesg("Updating@member conference lists"));
    if ((fp = fopen(mkpath(MEMBR,confname),"r"))==NULL) {
       puts(mesg("Can't update"));
       free(cp);
       return;
       }
    while (fscanf(fp,"%s",unam) != EOF)
       if (strcmp(unam,username)) /* dont add moderator */
          add_member(unam,cp);
    fclose(fp);
    free(cp);
}
 
m_add_membr()  /* add member(s) to conference */
{
 FILE *fp, *fopen();
 char *mkpath();

 if ((fp=fopen(mkpath(MEMBR,confname),"a"))==NULL)
    puts(mesg("Can't add members."));
 else {
    rgst_users(confnode,fp);
    fclose(fp);
    }
}
 
m_rmv_membr()   /* remove member(s) from current conf */
{
  char mname[NMSIZE];
  FILE *fmp, *fopen();
  char *mkpath();

   if (eoln())
       getlin(0,"Name(s) to remove: ");
   while (!eoln()) {
       scan(mname);
       if (strcmp(mname,"all")==0) {
          if (yorn("Remove ALL participants",' ')) {
             if ((fmp = fopen(mkpath(MEMBR,confname),"r")) != NULL) {
                while (fscanf(fmp,"%s",mname) != EOF)
                    remov_conf(mname,confname);
                fclose(fmp);
                unlink(mkpath(MEMBR,confname));
                printf("All participants removed.\n");
                } 
             break;
             }
          }
       remov_conf(mname,confname);
       filter(mkpath(MEMBR,confname),mname);
       printf(mesg("Member '%s' removed.\n"),mname);
       }
}

remov_conf(membr,cname)  /* remove 'cname' from membr's conflist */
char *membr, *cname;
{
   char *mkpath(), *fn, fsn[20];
   char nm[NMSIZE], tnm[NMSIZE];
   int  k, count, tcnt;
   FILE *fp, *fs, *fopen();
   char *mktemp();
   char *templat = "/tmp/CRCXXXXXX";
   int cpythis;
   int magic, mnum, inod;

#ifdef DEBUG
  printf(" removing '%s' from '%s' conflist\n",cname,membr);
#endif

   fn=mkpath(CONF,membr);
   if ((fp=fopen(fn,"r"))==NULL)
      return(-1);
   strcpy(fsn,templat);
   mktemp(fsn);
   if ((fs=fopen(fsn,"w+"))==NULL) {
      fclose(fp);
      return(-1);
      }
/************ critical section ***************/
   lock(fn);
   fscanf(fp,"%d",&mnum);
   if (magic = (mnum==9906))
     fprintf(fs,"9906 ");
   else
     rewind(fp);
   while (fscanf(fp,"%d%s",&count,nm) != EOF) {
      cpythis = strcmp(nm,cname);
      if (cpythis)
         fprintf(fs,"%d %s\n",count,nm);
      for (k=1; k<=count; k++) {
         fscanf(fp,"%s%d",tnm,&tcnt);
      if (magic)
          fscanf(fp,"%d",&inod);
      if (cpythis) {
          fprintf(fs,"%s %d",tnm,tcnt);
          if (magic)
           fprintf(fs," %d\n",inod);
          else
           fprintf(fs,"\n");
          }
         }
      }
   fclose(fp); fp = fopen(fn,"w");
   rewind(fs);
   filecopy(fs,fp);
   fclose(fp);
   unlock(fn);
/************ end critical section ************/
   fclose(fs);
   unlink(fsn);
   return(0);
}
