/**************************************************************************
*    CoSy conferencing system, written by Alastair Mayer
*    
*    Copyright (C) 1984 University of Guelph
*
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program; if not, write to the Free Software
*    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*
***************************************************************************/

/*******************************************************
* COSY(tm) Computer-Based Conferencing System          *
* Written by: Alastair J.W. Mayer                      *
*******************************************************/
moderator()
{
  char cname[NMSIZE];
  int k;

  quit_conf();  /** Do this or could end up moderating current conf! */
  if (no_priv(3)) { flush(); return; }
  scan(cname);
  if ((k=lookup(cname,MOD_SS)) == NULL_K) {
     printf("Conference name"); getlin(0,"? ");
     scan(cname);
     }
  if (k == NEW_K) {
#ifdef BIX
     if (no_priv(4)) {  /* priv level to create new */
#else
     if (no_priv(3)) {
#endif
        flush();
        return;
        }
     modparse(cname);
     }
  else {
      if (numeric(cname)) {   /* temporary to disallow mod conv.s */
         tout("Sorry, moderating conversations can be hazardous to\n");
         tout("the health of your files.  This feature has been\n");
         tout("temporarily withdrawn.\n");
         flush();
         return;
         }
      switch (is_mod(username,cname)) {
         case -1:
           printf(mesg("No conference '%s', use 'mod new <name>' to create.\n"),
                    cname);
            break;
         case -2:
            printf(mesg("You are not the moderator of this conference.\n"));
            break;
         case 0:
         case 1:
            Subsys = MOD_SS;
            logger("MODERATE",cname);
            join_conf(cname,"");
            modparse("");
            Subsys = MAIN_SS;
            break;
         default: break;
        }
     }
}

is_mod(unm,cnm) /* return non-zero if user unm is not moderator of cnm */
char *unm, *cnm;
{
   FILE *fp, *fopen();
   char modname[NMSIZE];
   char *mkpath();
   char c;

   if ((fp=fopen(mkpath(HDR,cnm),"r")) == NULL)
      return(-1);
   else {
      if (Privilege > 10 && strcmp(unm,username)==0) {
         fclose(fp);
         return(1);   /* priv user can mod anything */
         }
      while ((c=getc(fp)) == ' ');
      ungetc(c,fp);                     /* skip any leading blanks */
      while (fscanf(fp,"%14[^ \n]%*[ ]",modname) > 0) {
         if (strcmp(modname,unm) == 0) {
            fclose(fp);
            return(0);  /* is (one of) a moderator */
            }
         }
     /* get to here if no match - not a moderator */
      fclose(fp);
      return(-2);
      }
}
