/**************************************************************************
*    CoSy conferencing system, written by Alastair Mayer
*    
*    Copyright (C) 1984 University of Guelph
*
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program; if not, write to the Free Software
*    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*
***************************************************************************/

/*******************************************************
* COSY(tm) Computer-Based Conferencing System          *
* Written by: Alastair J.W. Mayer                      *
*******************************************************/
m_rmv_topic(nm)    /* remove topic(s?) from current conf */
char *nm;
{
   char tnam[20], name[20], uname[20];
   struct cnode *cp, *cnalloc();
   struct tnode *tp, *tfind(), *mk_tnode();
   FILE *fp, *fopen();
   char *mkpath();

   if (strlen(nm) > 0)
      strcpy(tnam,nm);
   else
       while (scan(tnam) == NULL)
           getlin(0,"Topic to remove? ");
   if (tfind(tnam,confnode) == NULL) {
       tout(fmt("No such topic '%s'.\n",tnam));
       return(-1);
       }
   /* remove the topicname from Header file */
   if (filter(mkpath(HDR,confname),tnam)) {
       tout(mesg("Can't remove."));
       return(-1);
       }
   /* build dummy node for updates */
   cp = cnalloc();
   tp = mk_tnode(tnam,0,0);
   name[0]='-'; strcpy(&name[1], confname);
   cp->c_name = name;
   cp->c_next = NULL;
   cp->n_topics = 1;
   cp->first = cp->last = tp;
   /* and update member conflists */
   tout(mesg("Updating@member conference lists"));
   tout("\n");
   if ((fp = fopen(mkpath(MEMBR,confname),"r"))==NULL) {
      tout("Can't update");
      free(cp);
      return(-1);
      }
   while (fscanf(fp,"%15s",uname) != EOF)
      if (strcmp(uname,username))  /* don't do moderator */
         add_member(uname,cp);
   fclose(fp);
   free(cp);
   /* now zap moderator's in-core list */
   rmv_tname(confnode,tnam);
   /* and that's it */
   return(0);
}
