/**************************************************************************
*    CoSy conferencing system, written by Alastair Mayer
*    
*    Copyright (C) 1984 University of Guelph
*
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program; if not, write to the Free Software
*    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*
***************************************************************************/

/*******************************************************
* COSY(tm) Computer-Based Conferencing System          *
* Written by: Alastair J.W. Mayer                      *
*******************************************************/
saying()   /* pick a random saying */
{
  int n;

    n = rand() & 0377;
    r_cookie(n);
}

r_cookie(n)    /*  read a saying from saying conf */
int n;
{
  FILE *fdir, *ftxt, *fopen();
  long offset, size;
  char *con = "epithets", *top = "sayings";

    if ((fdir=fopen(mkpath(DIR,con,top),"r"))==NULL)
     return(-1);
    if ((ftxt=fopen(mkpath(TXT,con,top),"r"))==NULL) {
     fclose(fdir);
     return(-1);
     }
    if (n == -1)  /* last */
     n = n_msgs(con,top);
    else if (n > n_msgs(con,top)) {
     fclose(fdir); fclose(ftxt);
     return(-1);
     }
    fseek(fdir,(P_SIZE * (n-1)),0);
    fscanf(fdir,P_FMT,&offset);
    fclose(fdir);
    fseek(ftxt,offset,0);
    fscanf(ftxt,"%10lx%*40c",&size);
 /* fprintf(Out,"Saying #%3d:\n-------------\n",n); */
    textcopy(ftxt,Out,size);
    fclose(ftxt);
    return(0);
}
