/**************************************************************************
*    CoSy conferencing system, written by Alastair Mayer
*    
*    Copyright (C) 1984 University of Guelph
*
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program; if not, write to the Free Software
*    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*
***************************************************************************/

/*******************************************************
* COSY(tm) Computer-Based Conferencing System          *
* Copyright (C) 1983, 1984, University of Guelph       *
* Author: Peter Jaspers-Fayer, Alastair Mayer          *
*******************************************************/

/* -- This is the HELP routine for the UoG conferencing system.

      If called without any arguments, or called as a modifier
         of a command, a list of commands/options is given.

      If called with one (or more) arguments, this routine will
         print help files that pertain to those arguments.

         Thus three conditions arise:

   User entry       Contents of <from>     Contents of <word>
   ----------       ------------------     ------------------
     help foo            ""                      foo
     help                ""                       ""
     foo ?             "foobar"                   ""
Where:
      foo = (possibly) short form of command
   foobar = full command name                               -- */


helper(from)            /* display (hopefully) helpful messages */
char *from;
{
char word[NMSIZE], *fullword;
int key;
  scan(word);    /** do this first! --A.M */
  if (strlen(word)==0) {
     if (strlen(from) != 0) {
        help_cmds(from);
        }
     else {
        help_cmds("main");
        }
     }
  else {
     while (strlen(word) > 0) {
          key=lookfor(word,(byte)255,&fullword,Vocab);
          if (key < 0) fullword = word;
          help_file(fullword,key); /* get help file for this command */
          scan(word);
          }
     }
}                                  /* exit */

help_cmds(word)          /* no args, give list */
char *word;
{
char file[20];
 strcpy(file,word);
 strcat(file,".cmds");
  if (flist(mkpath(HDOC,file,"")))
     printf(mesg("No help available for options of command '%s'.\n"),word);
}

help_file(file,key)       /* full help on a particular command */
int key;
char *file;
{
  switch(key) {
    case  ERR_K: if (flist(mkpath(HDOC,file,""))) {   /* try this first */
       printf("Unknown word, enter 'help commands' for a list of all valid\n");
       printf("commands, or 'help' for a list of commands at this level.\n");
       }
       return;
    case AMBIG_K: tout("Ambiguous keyword. ");
                  lstambig(file,(byte)255);
                  tout("Or enter 'help commands' for a complete list.\n");
                  return;
    default:
            if (flist(mkpath(HDOC,file,"")))
           printf(mesg("No help available for command '%s'.\n"),file);
            }
}

error(n)
int n;
 {
  printf("Error: ");
  switch (n)
    {
    case AMBKEY: printf("Ambiguous entry.\n"); break;
    case BADKEY: printf("Unrecognized entry.\n"); break;
    default:     printf( "UNDEFINED ERROR\n");
    }
   flush(); /* drop rest of input */
}
