/**************************************************************************
*    CoSy conferencing system, written by Alastair Mayer
*    
*    Copyright (C) 1984 University of Guelph
*
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program; if not, write to the Free Software
*    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*
***************************************************************************/

/*******************************************************
* COSY(tm) Computer-Based Conferencing System          *
* Copyright (C) 1983, 1984, 1985, University of Guelph *
* Written by: Alastair J.W. Mayer                      *
*******************************************************/
/* new lookup routines */
/* new lookup routines */
lookup(word,mask)  /* simple lookup routine */
char word[];
ushort mask;
{
    char *dummy;
    int n;

    n =lookfor(word,mask,&dummy,Vocab);
    return(n);
}

lookfor(word,msk,fullwd,vptr)  /* lookup word from those with matching key */
char word[];
ushort msk;
char *fullwd[];
struct wdtbl *vptr;
{
  struct wdtbl *vp;
  int k,kl,kr;

  if ((vp = vptr) == NULL) return(ERR_K);
  if (word[0] == '\0') return(NULL_K);
  if (isdigit(word[0])) {
     if (numeric(word))
        return(NUMBER_K);
     else
        return(ERR_K);
     }
  if ((msk & vp->ss) && (StrCmp(word,vp->wrd) == 0)) {
     *fullwd = vp->wrd;
     k = vp->key;
     }
  else
     k = ERR_K;
  kr = lookfor(word,msk,fullwd,vp->right);
  if (kr == AMBIG_K) return(kr);
  if (kr!=ERR_K && k!=ERR_K) return(AMBIG_K);
  kl = lookfor(word,msk,fullwd,vp->left);
  if (kl == AMBIG_K) return(kl);
  if (kr==ERR_K && kl==ERR_K) return(k);
  if (k==ERR_K && kr==ERR_K) return(kl);
  if (k==ERR_K && kl==ERR_K) return(kr);
  /* can we get to here? */
  return(AMBIG_K);
}
