/**************************************************************************
*    CoSy conferencing system, written by Alastair Mayer
*    
*    Copyright (C) 1984 University of Guelph
*
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program; if not, write to the Free Software
*    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*
***************************************************************************/

/*******************************************************
* COSY(tm) Computer-Based Conferencing System          *
* Copyright (C) 1983, 1984, 1985, University of Guelph *
* Written by: Alastair J.W. Mayer                      *
*******************************************************/
mksynonym(word,syn)  /* make syn a synonym for word */
char *word, *syn;
{
  struct wdtbl *wp, *findvp();
  ushort ssys;
  int kval;
  char fullwd[NMSIZE];
  char *flwd;

  if (lookup(syn,ALL_SS) != ERR_K) {
     printf("Sorry, '%s' is already defined or is ambiguous.\n",syn);
     return;
     }
  if ((kval=lookfor(word,ALL_SS,&flwd,Vocab)) == ERR_K || kval == AMBIG_K) {
     printf("'%s' is an ambigous or unknown command.\n",word);
     return;
     }
  strcpy(fullwd,flwd);
  wp = findvp(fullwd,Vocab);
 if (wp == NULL) {
   printf("Can't create synonym.\n");
   return;
   }
  ssys = wp->ss;
  kval = wp->key;
  enterwd(strsave(syn),ssys,kval);
  if (!Terse)
     printf("'%s' is now a synonym for '%s'\n",syn,word);
}

struct wdtbl *findvp(wd,vptr) /* find wd in vocab tbl, return ptr to entry */
char *wd;
struct wdtbl *vptr;
{
   struct wdtbl *vp;
   int cmp;
 
   if ((vp = vptr) == NULL) return (NULL);
   if (*wd == '\0') return(NULL);
   if ((cmp=strcmp(wd,vp->wrd))==0) {
      return(vp);
      }
   if (cmp > 0) 
      return(findvp(wd,vp->right));
   else
      return(findvp(wd,vp->left));
}
