/**************************************************************************
*    CoSy conferencing system, written by Alastair Mayer
*    
*    Copyright (C) 1984 University of Guelph
*
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program; if not, write to the Free Software
*    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*
***************************************************************************/

/*******************************************************
* COSY(tm) Computer-Based Conferencing System          *
* Copyright (C) 1983, 1984, 1985, University of Guelph *
* Written by: Alastair J.W. Mayer                      *
*******************************************************/
optparse(pfp)  /* parser for "option" subsystem */
FILE *pfp;  /* in case scanning profile file */
{
   int key;
   int cont = 1;
   char word[NMSIZE];
#ifdef UOG_2
   char cork();
#else
   char kxorc();
#endif UOG_2
   int ss_save;  /* save subsystem */

   ss_save = Subsys;
   Subsys = OPTION_SS;
   while (cont) {
      if (eoln())
         getlin(pfp,"Opt:");
   while (cont && 0==eoln()) {
      scan(word);
      key = lookup(word,OPTION_SS);
      switch (key) {
         case EDT_K:
            scan(word);
            if (*word == 'v')
               strcpy(Editor,ED_V);
            else if (*word == 'q')
               strcpy(Editor,ED_Q);
            else {
               if (vorq(mesg("Set editor to$verbose or quiet")))
                  strcpy(Editor,ED_V);
               else
                  strcpy(Editor,ED_Q);
               }
            break;
         case UPLD_K:
#ifdef UOG_2
            switch (cork("Upload protocol: CMST or KERMIT",'C')) {
#else
            switch (kxorc("Upload protocol: KERMIT, XMODEM or CMST",'K')) {
                case 'x': strcpy(Up_Prtcl,"xmodem");
                          break;
#endif UOG_2
                case 'k': strcpy(Up_Prtcl,"kermit");
                          break;
                case 'c': strcpy(Up_Prtcl,"cmst");
                }
             break;
         case DNLD_K:
#ifdef UOG_2
             switch (cork("Download protocol: CMST or KERMIT",'C')) {
#else
             switch (kxorc("Download protocol: KERMIT, XMODEM or CMST",'K')){
                case 'x': strcpy(Dn_Prtcl,"xmodem");
                          break;
#endif UOG_2
                case 'k': strcpy(Dn_Prtcl,"kermit");
                          break;
                case 'c': strcpy(Dn_Prtcl,"cmst");
                }
            break;
         case TERM_K:
            scan(word);
            if (StrCmp(word,"pagelength")==0) {
               scan(word);
               if (lookup(word,OPTION_SS) == NUMBER_K) 
                  sscanf(word,"%d",&PageLen);
               else
                  tout("A number was expected.\n");
               }
            else if (StrCmp(word,"width")==0 || StrCmp(word,"linelength")==0) {
               scan(word);
               if (lookup(word,OPTION_SS) == NUMBER_K) 
                  sscanf(word,"%d",&LinWidth);
               else
                  tout("A number was expected.\n");
               }
            else if (StrCmp(word,"erase")==0) {     /* set erase char */
               if (bord("Erase character: BACKSPACE or DELETE",'B'))
                  system("stty erase \"^h\"");
               else
                  system("stty erase \"^?\"");
               }
            else {
               tout("Unrecognized terminal sub-option.\n");
               tout("Sub options are: pagelength, width.\n");
               }
            break;
         case SYN_K:
            { char wdnew[NMSIZE], wdold[NMSIZE];

              while (scan(wdnew)==NULL) 
                 getlin(pfp,"New command name? ");
              while (scan(wdold)==NULL)
                 getlin(pfp,"Synonym for ?");
              mksynonym(wdold,wdnew);
             }
            break;
         case HELP_K:
            helper("option");
            break;
         case QUIT_K:
            cont = NO;
            break;
         case NULL_K:
            break;
         case AMBIG_K:
            error(AMBKEY);
            lstambig(word,OPTION_SS);
            break;
         case ERR_K:
         default:
            if (StrCmp(word,"terse")==0) {
               Terse = YES;
               }
            else if (StrCmp(word,"verbose")==0) {
               Terse = NO;
               }
            else if (StrCmp(word,"chat")==0) {
               if (yorn("Allow CHAT",' '))
                  chat_sw('y');
               else
                  chat_sw('n');
               }
            else if (StrCmp(word,"filter")==0) {
               Filter = yorn("Filter control chars",'Y');
               }
	    else if (StrCmp(word,"graphics")==0) {
	       if (yorn("Display graphics",'Y')) {
		  Filter = NO;
		  PageLen = 0;
		  LinWidth = MAXINT;
		  Naplps = YES;
		  }
	       else {
		  Filter = YES;
		  PageLen = 20;
		  LinWidth = 80;
		  Naplps = NO;
		  }
	       }
	    else if (StrCmp(word,"naplps")==0) {
	       Naplps = yorn("Transmit NAPLPS PDIs",'N');
	       }
            else {
                error(BADKEY);
                lstambig("",OPTION_SS);
              }
            break;
         }
    } /* end while */
 } /* end while */
  Subsys = ss_save;
}

chat_sw(sw)  /* toggle chat mode */
char sw;
{
  char *ttyname();
  if (fork()==0) {
   if (setuid(getuid()))  /* set uid to real uid */
      perror("chat: setuid: ");
   setgid(getgid());
   if (sw=='y')
      if (chmod(ttyname(0),0722))
         perror("chat: chmod:");
   if (sw=='n')
      if (chmod(ttyname(0),0700))
         perror("chat: chmod:");
    exit(0);
    }
}
/*   prompts with suffix and gets a line from the user to see if answer was
*    c (returns 1), k (returns 0), .
*    If cr is done, does default or prompts again.
*/

#ifdef UOG_2
char cork(promptprefix,deflt)
#else
char kxorc(promptprefix,deflt)
#endif
char      *promptprefix ;
char deflt;
{
     char line[ BUFSIZ ] ;
     char *chp ;
     char wd[20];
     char *fgets() ;

     if (! eoln()) {    /* allow it on same line */
        scan(wd);
        if (*wd == 'c') return('c');
        if (*wd == 'k') return('k');
#ifndef UOG_2
        if (*wd == 'x') return('x');
#endif
      /* else ignore & prompt */
        }
     while (1)
     {
#ifdef UOG_2
	  printf("%s (c/k)? %c\b", promptprefix,deflt);
#else
          printf("%s (k/x/c)? %c\b", promptprefix,deflt);
#endif
          fgets( line, BUFSIZ, stdin ) ;
          for( chp = line ; *chp == '\t'|| *chp == ' '; chp++ ) ;
               if( *chp == '\0')
               {
                    fprintf( stderr, "Input line too long\n" );
                    exit( 1 ) ;
               }
          if (*chp == '\n') *chp = deflt;
          switch ( *chp ) {
          case 'k':
          case 'K':
               return( 'k' ) ;
               break ;
          case 'c':
          case 'C':
               return( 'c' ) ;
	  case ' ':
	       continue;
#ifndef UOG_2
          case 'x':
          case 'X':
               return( 'x' );
               break;
	  default:
               printf("Enter 'kermit', 'xmodem', or 'cmst'.\n");
#else
	  default:
	       printf("Enter 'cmst' or 'kermit'.\n");
#endif UOG_2
               continue ;
          }
     }
}

bord(prompt,deflt)  /* get a b(ackspace) or d(elete) */
char *prompt;
char deflt;
{
     char ln[BUFSIZ];
     char *chp;
     char wd[20];
     char *fgets();

     if (!eoln()) {
        scan(wd);
        if (*wd == 'b') return(1);
        if (*wd == 'd') return(0);
        }
     while (1) {
        printf("%s (b/d)? %c\b", prompt, deflt);
        fgets(ln, BUFSIZ, stdin);
        for (chp=ln; *chp == '\t' || *chp == ' '; chp++ );
           if (*chp == '\0') 
              fprintf(stderr,"Input line too long\n");
        if (*chp == '\n') *chp = deflt;
        switch (*chp) {
           case 'b':
           case 'B':
              return(1);
           case 'd':
           case 'D':
              return(0);
           case ' ':
              continue;
           default:
              printf("Choose 'backspace' or 'delete'.\n");
              continue;
           }
       }
}
