/**************************************************************************
*    CoSy conferencing system, written by Alastair Mayer
*    
*    Copyright (C) 1984 University of Guelph
*
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program; if not, write to the Free Software
*    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*
***************************************************************************/

/*******************************************************
* COSY(tm) Computer-Based Conferencing System          *
* Written by: Alastair J.W. Mayer                      *
*******************************************************/

parse(pfp)
FILE *pfp;  /* if NULL, then input from tty, else profile file */
   {
   int key;
   int cont = 1;
   char word[NMSIZE];
   char nxtwd[NMSIZE];
   char prompt[15] ;
   char *tymestamp();
   FILE *fopen(), *fp;
   char *mkpath(), *mktemp();
   char *scan();

#ifdef DEBUG
  printf("-parser entered\n");
#endif
 while (cont) {
   if (Subsys == READ_SS)
      switch (rd_direc) {
         case BKWD_K: strcpy(prompt,clip("RB:|Read Bkwd:")); break;
         case REFR_K: strcpy(prompt,clip("Rf:|Read Ref:")); break;
         case FWRD_K: default:
            strcpy(prompt,clip("R:|Read:")); break;
         }
   else if (Subsys == MAIL_SS) strcpy(prompt,clip("C:|Conv:"));
   else if (Subsys == MEMO_SS) strcpy(prompt,clip("M:|Mail:"));
   else strcpy(prompt,":");
   cont = getlin(pfp,prompt);
#ifdef DEBUG
 printf("-got a line\n");
#endif
   file_flag = OFF;
   print_flag = OFF;
   Rd_hdr_flag = OFF;
   Out = stdout;
#ifdef DEBUG
printf("-resetting file vars\n");
fflush(stdout);
#endif
   if (Fyl != NULL) {
      fclose(Fyl);
      Fyl = NULL;
      }
   while (cont && 0==eoln())
      {
      (void) scan(word);
#ifdef DEBUG
 printf("-scanned '%s'\n",word);
 fflush(stdout);
#endif
      key=lookup(word,MAIN_SS);
#ifdef DEBUG
printf("key=%d\n",key);
fflush(stdout);
#endif
      switch (key)
         {
         case FILE_K:
            file_flag = ON;
            if (Fyl == NULL) {
               Fyl = fopen(mkpath(SCRATCH,username),"a");
               }
            if (Fyl != NULL)
               Out = Fyl;
            break;
         case PRNT_K:
            (void) scan(nxtwd);
            if (strlen(nxtwd)==0) {
               puts(mesg("Nothing to print."));
               break;
               }
            unscan(nxtwd);
            print_flag = ON;
            if (Prt == NULL) {
               strcpy(PrtFyl,mktemp("/tmp/CoSyXXXXXX"));
               Prt = fopen(PrtFyl,"w");
               fp = fopen("Banner","r");
               if (fp != NULL && Prt != NULL) {
                  filecopy(fp,Prt);
                  fclose(fp); fp = fopen(mkpath(RES,username),"r");
                  if (fp != NULL) {
                     copyln(fp,Prt);
                     fclose(fp);
                     }
                  putc('\f',Prt);
                  }
               }
            if (Prt != NULL) Out = Prt;
            break;
         case MEMO_K:
            quit_conf();  /* detach active conf, if any */
            Subsys = MEMO_SS;
            logger("MAIL","");
            memo_main();
            scan(nxtwd);
            if (strlen(nxtwd)==0)
               strcpy(nxtwd,"status");
            memo_parse(nxtwd);
            break;
         case MAIL_K:
            quit_conf();   /* disconnect any pointers */
            Subsys = MAIL_SS;
            logger("CONVERSE","");
            mailman("");
            break;
         case HELP_K:
            if (Subsys == READ_SS)
               helper("read");
            else if (Subsys == MAIL_SS)
               helper("converse");
            else if (Subsys == MEMO_SS)
               helper("mail");
            else
               helper("");
            break;
         case NULL_K:
            if (Subsys == MEMO_SS) {
               memo_parse("");
               break;
               }
            else
            if ( ! joined_flag) {
               join_1st();
               break;
               }
            else {
               reader(""); /* NB we dont fall thru incase its really MAIL */
               break;
               }
         case READ_K:
            Subsys = READ_SS;
            reader("");
            break;
         case JOIN_K:
            joiner("");
            break;
         case MOD_K:
            moderator();
            break;
         case SHOW_K:
            lister();
            break;
         case EDT_K:
            editer();
            break;
         case OPT_K:
            optparse(pfp);
            break;
         case BYE_K:
            if (strlen(word) >= 2 || yorn("bye",' ')) {
               if (Prt != NULL) fclose(Prt);
               hi_bye(BYE_K);
               cont=0;
               exit(0);
               }
            break;
         case PASS_K:
               ch_pass(0); 
               break;
	 case WHO_K:
	       system("/bin/ls /tmp/CU");
	       break;
         case NUMBER_K:
         case ERR_K:
            if (Subsys == READ_SS) {
               reader(word); }
            else if (Subsys == MAIL_SS) {
               mailman(word); }
            else if (Subsys == MEMO_SS) {
               memo_parse(word); }
            else if (strcmp(word,"time")==0) {
               fputs(tymestamp(),Out);
               fputs("\n",Out);
               }
            else if (strcmp(word,"author")==0) {
               flist(mkpath(HDOC,"author"));
               }
            else if (strcmp(word,"news")==0) {
               flist("MotD");
               }
            else if (strcmp(word,"status")==0) {
               rpt_stats();
               }
            else if (strcmp(word,"echo")==0) {
               fprintf(Out,"%s\n",&line.txt[line.ptr]);
               flush();
               }
            else if (strcmp(word,"terse")==0) {
               Terse = 1;
               }
            else if (strcmp(word,"verbose")==0) {
               Terse = 0;
               }
            else if (strcmp(word,"cookie")==0) {
               saying();
               }
            else if (strcmp(word,"abort")==0) {
               if (yorn("Really abort",' ')) {
                  logger("ABORT","");
                  exit(0);
                  }
               }
            else if (strcmp(word,"setpriv")==0 && Privilege >= 8) {
               Privilege +=2;  /* has to be at least 8 to start */
               }
#if 0
            else if (strcmp(word,"message")==0 && Privilege >= 8) {
               message();
               }
#endif
            else if (strcmp(word,"du")==0 && Privilege > 9) {
               (void) scan(word);
               del_usr(word);
               }
            else if (strcmp(word,"memo")==0) 
                memo_main();
            else if (strcmp(word,"chat")==0)
                chat("");
            else if (joiner(word))
                 /* then joiner handled it */ ;
            else {
               error(BADKEY);
               lstambig("",MAIN_SS);
               }
            break;
         case AMBIG_K:
            error(AMBKEY);
            lstambig(word,MAIN_SS);
            break;
         default:
            error(BADKEY);
            break;
         }
       }
     }
}
