/**************************************************************************
*    CoSy conferencing system, written by Alastair Mayer
*    
*    Copyright (C) 1984 University of Guelph
*
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program; if not, write to the Free Software
*    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*
***************************************************************************/

/*******************************************************
* COSY(tm) Computer-Based Conferencing System          *
* Written by: Alastair J.W. Mayer                      *
*******************************************************/
#define CHEOF (char) EOF
extern int MailFlag;
extern int errno;

getlin(pfp,pc)  /* get line into ln */
FILE *pfp;
 char *pc;  /* prompt char */
   {
   line_ty *ln;
   extern line_ty line;
   char c;
   int i;
   int timeout();

   ln= &line;

   errno = 0;
   if (pfp == NULL || isatty(fileno(pfp)) ) {  /* terminal input */
      if (MailFlag) {
         puts("*You have mail!*\007");
         MailFlag = NO;
         }
      printf("%s",pc);
      for (i=0; i<LIM-1 && (c=getchar()) !='\n'; ++i) {
        if (c==CHEOF)
           if (errno==EINTR) {
              --i;
              continue;
              }
           else
              break;
        ln->txt[i] = c;
        }
      LineCnt = 0;
      }
   else {
      fflush(stdout);
      for (i=0; i<LIM-1 && (c=getc(pfp)) !='\n'; ++i) {
        if (c==CHEOF)
           if (errno==EINTR) {
              --i;
              continue;
              }
           else
              break;
        ln->txt[i] = c;
        }
      }
   if (c == CHEOF)
      return(0);
   if (c == '\n')
      ln->txt[i++] = '\0';
   ln->txt[i] = '\0';
   if (ln->txt[1]=='\0') {  /* make null input = 1 blank */
      ln->txt[1]=' ';
      ln->txt[2]='\0';
      i = 2;
      }
   ln->siz = i-1;
   ln->ptr = 0;
   return(1);
   }

eoln()  /* return true if end of ln */
   {
 line_ty *ln;
 extern line_ty line;
 extern line_ty line;
 ln= &line;
   return(ln->ptr >= ln->siz);
   }

StrCmp(s,t)  /* return <0 if s<t, 0 if s==t, >0 if s>t */
char *s, *t;
   {
#if (DEBUG>4)
 printf(" -- stringcompare=");
 printf("%s",s);printf("/");printf("%s",t);
 printf("\n");
#endif
   for ( ; *s == *t; s++, t++)
      if (*s == '\0')
         return(0);
   if (*s == '\0') return(0); /* for substrings */
   return( *s - *t);
   }

char * scan(wd)   /* read next wd from input line - return NULL if eol */
char wd[];
   {
   line_ty *ln;
  extern line_ty line;
   register int i,j;
#ifdef DEBUG
printf(" -scanning\n");
fflush(stdout);
#endif

   ln= &line;
   i=ln->ptr;
   while (i<=ln->siz && ln->txt[i]!='?' && ln->txt[i]!='_' && ln->txt[i]!='@' &&
         ln->txt[i] != '.' &&
         ln->txt[i] != ';' &&
         (0==isalnum(ln->txt[i])))
      i++;
   j = 0;
   if (ln->txt[i] == '@') {  /* special for mail address */
      wd[j] = '@';
      i++;
      j++;
      }
  else if (ln->txt[i] == ';') {  /* signal null (eoln) */
    *wd = 0;
    i++;
    j++;
    }
   else
   while (isalnum(wd[j]=ln->txt[i]) || wd[j]=='.' || wd[j]=='_' || wd[j]=='?')
        {
        if (isupper(wd[j]))
           ln->txt[i]=wd[j]=tolower(wd[j]);
          /* makes life easier in 'create_topics' */
        i++;
        j++;
        if (j >= NMSIZE) break;  /* don't ovflo input */
        }
   wd[j]='\0';
   ln->ptr=i;
#ifdef DEBUG
printf(" -endscan word '%s'\n",wd);
fflush(stdout);
#endif
   if (*wd == 0) 
       return(NULL);
   else
       return(wd);
}
