/**************************************************************************
*    CoSy conferencing system, written by Alastair Mayer
*    
*    Copyright (C) 1984 University of Guelph
*
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program; if not, write to the Free Software
*    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*
***************************************************************************/

/** pathnames.h -- this file contains pathnames & filenames that may change
 * depending on where and how COSY is installed.   Note that there is
 * no need for conferences (the 'c' directory), userfiles ('u') or
 * even helpfiles ('h' directory) to be on the same parent directory,
 * or even on the same filesystem.
 *   The names here are set up for the "sample" included with the
 * distribution tape, and assumes they were installed on "/usr/CoSy"
 * thus the hierarch /usr/CoSy/sample.  This could (and should) be changed of
 * course (but be wary of too-deep pathnames for efficiency sake).
 *
 *      -- Alastair Mayer
 **/

/* 2-feb-2001: added MPATH for createdirs -- ajwm */

/*** file pathways, used in routine 'mkpath'  ***/
#define UPATH "/CoSy/users/"   /* user directories  files */
#define CPATH "/CoSy/confs/"    /* conf. dirs + text files, inc mail */
#define HPATH "/CoSy/help/"   /* help text files */
#define SPATH "/CoSy/NextMail"  /* holds next mail number */
#define NU_PROFYL "Nu.Profile"

/* the following are for "show group", which should really use mkpath() */
#define GRPLIST "/CoSy/confs/GroupList"
#define GRPNAME "/CoSy/confs/Groups/"

/* the following are used mainly in "memo" */
#define U_MEM_IN "/CoSy/users/%s/Memo_in"
#define U_MEM_OUT "/CoSy/users/%s/Memo_out"
/* NB current version (3.1.3) expects the memo spool area
*  (eg /usr/memo/spool) to be on the same filesystem as "/usr/tmp",
*  because it makes a link.  (Does its own "mv").
**/
#define MPATH "/CoSy/memo/"
#define MSPLPATH "/CoSy/memo/spool/"
/* define tmp file instead of /usr/tmp */
#define MTMPATH  "/CoSy/memo/tmp/"

/* define MEMTMP as a mkpath() call */
#define MEMTMP mkpath(MEM_TMP,"","")

/* the following is used by the logging routine */
#define LOGFILE "/CoSy/cosylogs/\0               "

/* "HERE" is used in memo as the local site (node) name */
#define HERE "TCOSY"

/* end pathnames.h */
