/**************************************************************************
*    CoSy conferencing system, written by Alastair Mayer
*    
*    Copyright (C) 1984 University of Guelph
*
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program; if not, write to the Free Software
*    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*
***************************************************************************/

/*******************************************************
* COSY(tm) Computer-Based Conferencing System          *
* Written by: Alastair J.W. Mayer                      *
*******************************************************/
add_parse(num)  /* parser for "read-add" subsystem */
int num;  /* last read num - parameter for write_msg */
{
   int key;
   int cont = 1;
   char word[NMSIZE];
   char *prompt;
   FILE *fscr, *fopen();
   ushort save_ss;

   if (filesize(mkpath(SCRATCH,username,"")) <=1)  /* nothing in scratchpad */
      return;
   save_ss = Subsys;
   Subsys = RD_AD_SS;
   if (Terse)
      prompt = "A:";
   else
      prompt = "Add/action:";
   while (cont) {
      getlin(0,prompt);
   while (cont && 0==eoln()) {
      scan(word);
      key = lookup(word,RD_AD_SS);
      switch (key) {
         case EDT_K:
             editmsg("SCRATCHPAD",SCRATCH);
            break;
         case ADD_K:
             if (write_msg(num,"")) /* couldn't add */
                break;   /* so don't clear */
         case CLEAR_K:
             if ((fscr = fopen(mkpath(SCRATCH,username,""),"w")) != NULL)
                fclose(fscr);    /* clear scratchpad */
         case QUIT_K:
            cont = NO;
            break;
         case LIST_K:  /* display msg (review) */
            flist(mkpath(SCRATCH,username,""));
            break;
         case HELP_K:
            helper("read.add");
            break;
         case NULL_K:
            break;
         case AMBIG_K:
            error(AMBKEY);
            lstambig(word,RD_AD_SS);
            break;
         case ERR_K:
         default:
            error(BADKEY);
            lstambig("",RD_AD_SS);
            break;
         }
    } /* end while */
 } /* end while */
   Subsys = save_ss;
}
