/**************************************************************************
*    CoSy conferencing system, written by Alastair Mayer
*    
*    Copyright (C) 1984 University of Guelph
*
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program; if not, write to the Free Software
*    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*
***************************************************************************/

/*******************************************************
* COSY(tm) Computer-Based Conferencing System          *
* Written by: Alastair J.W. Mayer                      *
*******************************************************/
/* macros for manipulating a bit-map read list */

#define NBITS 8

#define has_read(n) (ReadList[(int)n/NBITS] & 1<<(n % NBITS))

r_mrk_rd(n,v)  /* mark msg n as read or not depending on v */
int n,v;
{
   register int nval;

   nval = ReadList[(int)n/NBITS] & ~(1 << (n%NBITS));
   return (ReadList[(int)n/NBITS] = nval | (v << (n%NBITS)) );
}
