/**************************************************************************
*    CoSy conferencing system, written by Alastair Mayer
*    
*    Copyright (C) 1984 University of Guelph
*
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program; if not, write to the Free Software
*    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*
***************************************************************************/

/*******************************************************
* COSY(tm) Computer-Based Conferencing System          *
* Written by: Alastair J.W. Mayer                      *
*******************************************************/
r_withdraw(who)   /* get msg no & withdraw it */
char who;
{
   int n; char wd[NMSIZE];
   int key;

   scan(wd);
   while ((key=lookup(wd,READ_SS)) == NULL_K) {
     getlin(NULL,"Message number? ");
     scan(wd);
     }
   if (key != NUMBER_K) {
     puts("Error, number expected.");
     return;
     }
   sscanf(wd,"%d",&n);
   del_msg(n,who);
}

del_msg(n,who)  /* flag msg n as deleted by who */
int n;
char who;
{
  char dkey, name[NMSIZE];
  long offset;
  char *mkpath();  FILE *ftex, *fopen();
  if (ftopic != NULL) {
     if (n < 1 || n_msgs(confname,topicname) < n) {
        printf("No such message #%d\n",n);
        return;
        }
     else {
        fseek(fmsgdir,(P_SIZE * (n-1)),0);
        fscanf(fmsgdir,P_FMT,&offset);
        fseek(ftopic,offset,0);
        fscanf(ftopic,"%*35c%c%14c",&dkey,name);
        if (dkey!=' '&& who!=' ') /* check later for restore*/ {
          printf("Already deleted by ");
          switch (dkey) {
          case 'W': puts("author"); return;
          case 'M': puts("moderator"); return;
          case 'S': puts("system manager"); return;
          }
          }
        deblank(name);
        if (who == ' ') {   /* its a restore */
           if (is_mod(username,confname) < 0) {
              tout("You're not a moderator of this conference.\n");
              return;
              }
           else switch (dkey) {
              case 'W': if (strcmp(name,username) != 0) {
                           tout("Not restored - withdrawn by author.\n");
                           return;
                           }
                        break;
              case 'M': /* okay fine */
                        break;
              case 'S': if (Privilege < 4) {
                           tout("Not restored - deleted by system manager.\n");
                           return;
                           }
                        break;
              default: tout("Not a deleted message.\n");
                        return;
                        break;
               }
           }
        if (who == 'W' && strcmp(name,username) != 0) {
             printf("You did not originate #%d\n",n);
             if ((is_mod(username,confname) >= 0) &&
                 (yorn("Delete as moderator?",' '))) {
                who = 'M';
                }
             else
                return;
          }
        /* okay to flag it, back up the write pointer */
        /* re-open so can write on it! */
           if ((ftex = fopen(mkpath(TXT,confname,topicname),"r+")) == NULL) {
          puts("Can't update message file.");
          return;
               }
#ifdef STDIOBUG
        setbuf(ftex,0);   /* get around stdio bug */
#endif
        fseek(ftex,offset+35L,0);
        fputc(who,ftex);
        fclose(ftex);
        /* make sure 'ftopic' buff is lost too */
        fseek(ftopic,0L,0);
           fscanf(ftopic,"%c",&dkey);  /* dummy read */
        fseek(ftopic,-10L,2);
        fscanf(ftopic,"%c",&dkey);  /* ditto */
        read_msg(n,NO,0);  /* just to prove its been done */
        }
     }
    else puts("No topic?");
  }
