/**************************************************************************
*    CoSy conferencing system, written by Alastair Mayer
*    
*    Copyright (C) 1984 University of Guelph
*
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program; if not, write to the Free Software
*    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*
***************************************************************************/

/*******************************************************
* COSY(tm) Computer-Based Conferencing System          *
* Written by: Alastair J.W. Mayer                      *
*******************************************************/
read_date()  /* return 1st message num after date */
{
   char date[NMSIZE];
   long int nsec, get_date(), date_read();
   char *ctime();
   int min, max, mtry;

     scan(date);
     nsec=get_date(date);
     /* do binary search for date */
     min=0;  max=n_msgs(confname,topicname);
     while ((max-min) > 1) {
         mtry = (int) min + (max-min)/2;
         if (date_read(mtry) > nsec)
          max = mtry;
         else
          min = mtry;
         }
     /* formerly, call read_msg(max) directly.  now returns value
      * for a call to rd_messages, to provide more uniform syntax.
      * (Thus, 'date 5jun84' is a msg num, like 'first' or 'last')
      */
     return(max);
}

long int date_read(n)  /* return date of msg n */
    int n;
    {
     long offset;
     time_t tym;

     if (fmsgdir == NULL) {
        return(0L);
        }
     fseek(fmsgdir,(long)(P_SIZE * (n-1)), 0);
     fscanf(fmsgdir,P_FMT,&offset);
     fseek(ftopic, offset+(long)(P_SIZE+3*M_SIZE),0);
     fscanf(ftopic,P_FMT,&tym);
     return(tym);
    }
