/**************************************************************************
*    CoSy conferencing system, written by Alastair Mayer
*    
*    Copyright (C) 1984 University of Guelph
*
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program; if not, write to the Free Software
*    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*
***************************************************************************/

/*******************************************************
* COSY(tm) Computer-Based Conferencing System          *
* Written by: Alastair J.W. Mayer                      *
*******************************************************/
read_skip()    /* skip n, to n, or bkwrd n */
{

  char wd[NMSIZE];
  int val, key1, key2;

#ifdef DEBUG
 puts("SKIPping messages");
#endif
  scan(wd);
  key1 = lookup(wd,READ_SS);
  if (key1 == TO_K || key1 == BKWD_K) {
     scan(wd);
     key2 = lookup(wd,READ_SS);
     switch (key2) {
     case DATE_K:  val = read_date(); break; /* allow 'skip to date dmy' */
     case FIRST_K: val = 1; break;
     case LAST_K:  val = n_msgs(confname,topicname); break;
     case NUMBER_K: sscanf(wd,"%d",&val); break;
        default: puts(mesg("Syntax error@(number expected)"));
                 return(-1);
     }
  }
  else if (key1 == NUMBER_K) sscanf(wd,"%d",&val);
  else {
     puts(mesg("Syntax error@(number, TO, or BACKWARD expected)"));
        return(-1);
      }
  switch (key1) {
     case NUMBER_K: val += topicnode->count; break;
     case BKWD_K:  val = topicnode->count - val; break;
     case TO_K:     /* val=val */ break;
     }
  if (val > 0 && read_msg(val,NO,0) >= 0) topicnode->count = val;
  for (val=1; val<=topicnode->count; val++)
     r_mrk_rd(val,YES);
  for (; val<=(TMAX*NBITS); val++)
     r_mrk_rd(val,NO);
  return(0);
}
