/**************************************************************************
*    CoSy conferencing system, written by Alastair Mayer
*    
*    Copyright (C) 1984 University of Guelph
*
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program; if not, write to the Free Software
*    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*
***************************************************************************/

/*******************************************************
* COSY(tm) Computer-Based Conferencing System          *
* Written by: Alastair J.W. Mayer                      *
*******************************************************/
#include <setjmp.h>
#include <signal.h>
tout(str)   /* print str, possibly with tty paging, etc */
char *str;
{
    /* global Out - current output file descriptor */
    /* if going to tty, keep track of line count, line width, etc */
    /* need global LineCnt, set to 0 after any read from tty */
    /* also need global ColCnt, set to 0 after a newline.    */
    /*  (but wot about tabs, eh?  foo)  */

   char c;  /* temp var -- could it be a register? */

   if (isatty(fileno(Out))) {
     if (ColCnt==0) {
      if (PageLen == 0) LineCnt = -1;
      if (LineCnt >= PageLen) 
         if (more_prompt() == NO)
            return(NO);
      }
      while (c = *str++) {         /* until EOS */
         if (ColCnt >= LinWidth && c != '\n') {
            putc('\n',Out);
            LineCnt++;
            if (PageLen == 0) LineCnt = -1;
            if (LineCnt >= PageLen) 
               if (more_prompt() == NO)
                  return(NO);
             putc(c,Out);
            ColCnt = 1; 
            }
         else
            putc(c,Out);
         ColCnt++;
         if (c == '\n') {
            ColCnt = 0;
            LineCnt++;
            }
         }
      }
   else       /** its not a tty, just shove it out */
      fputs(str,Out);
   return(YES);
}

more_prompt()    /* ask 'more..', check for 'quit' */
{
   register int retval = YES;
   register char c;
   extern jmp_buf Env;
   extern void timeout(int);

   LineCnt = 0;
   if ( ! Paging)    /* we're not counting */
      return(retval);
   setjmp(Env);
   printf(".More.."); fflush(stdout);
   signal(SIGALRM,timeout);  alarm(300);
   if ((c = getchar()) == 'q' || c == 'n' || c == 'Q' || c == 'N')
      retval = NO;
   while (c != '\n') c = getchar();
   signal(SIGALRM, SIG_IGN);  alarm(0);
   return(retval);
}

  /* UTS defines sprintf() to return char pointer,
   * most UNIXes don't, though.
   */
 /*VARARGS1*/
char *fmt(str,a,b,c,d,e,f,g,h,i,j) /* return pointer to formatted string */
   char * str;
{
   static char work[150];

   sprintf(work,str,a,b,c,d,e,f,g,h,i,j);
   return(work);
}
