/**************************************************************************
*    CoSy conferencing system, written by Alastair Mayer
*    
*    Copyright (C) 1984 University of Guelph
*
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program; if not, write to the Free Software
*    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*
***************************************************************************/

/*******************************************************
* COSY(tm) Computer-Based Conferencing System          *
* Copyright (C) 1984, 1985, University of Guelph       *
* Written by: Alastair J.W. Mayer                      *
*  This version calls an external registration script, *
* which returns the new username via a pipe.           *
*******************************************************/
char *add_user(uname)  /* register new user 'name' */
char *uname;
{
      FILE *fp, *popen();
      int sig_hup();

      signal(SIGHUP,SIG_DFL);   /* don't trap hangups here */
      if ((fp = popen("/byte/testreg/register","r")) != NULL) {
         fscanf(fp,"%14s",uname);
         if (pclose(fp)) { /* bad return status */
           puts("Bad return status from registration.");
           puts("Sorry, unable to continue session.");
           exit(1);
           }
         }
      else {
         puts("Sorry, unable to initiate registration procedure.");
         puts("Registrations disabled or system problem.");
         exit(1);
         }
      if (strcmp(uname,"new")==0 || strlen(uname)==0) {
         puts("Improper or incomplete registration. Sorry");
         exit(1);
         }
      signal(SIGHUP,sig_hup);     /* trap hangups again */
      return(uname);
}
