/**************************************************************************
*    CoSy conferencing system, written by Alastair Mayer
*    
*    Copyright (C) 1984 University of Guelph
*
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program; if not, write to the Free Software
*    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*
***************************************************************************/

/*******************************************************
* COSY(tm) Computer-Based Conferencing System          *
* Copyright (C) 1983, 1984, 1985, University of Guelph *
* Written by: Alastair J.W. Mayer                      *
*******************************************************/
#include <stdlib.h>
#ifdef UTS
#include "memo/memo.h"
/*  UTS make, include work different */
#else
#include "../memo/memo.h"
#endif
 initkw()    /* initialize vocab table */
{
   Vocab = (struct wdtbl *) malloc(sizeof(struct wdtbl));
   Vocab->wrd = "help"; Vocab->ss = ALL_SS; Vocab->key = HELP_K;
   Vocab->left = Vocab->right = NULL;
 /* current version of 'enterwd()' requires at least one already entered */
   enterwd("read",  MAIN_SS|MEMO_SS, READ_K);
   enterwd("rdonly", MOD_SS, READ_K);
   enterwd("join",  MAIN_SS, JOIN_K);
   enterwd("show",  MAIN_SS, SHOW_K);
   enterwd("bye",   MAIN_SS, BYE_K);
   enterwd("converse",  MAIN_SS|SHOW_SS, MAIL_K);
   enterwd("mail",  MAIN_SS|SHOW_SS, MEMO_K);
   enterwd("file",  MAIN_SS, FILE_K);
   enterwd("moderate",   MAIN_SS, MOD_K);
   enterwd("edit",  MAIN_SS|M_SD_SS|RD_AD_SS|OPTION_SS, EDT_K);
   enterwd("clear", RD_AD_SS|M_SD_SS, CLEAR_K);
#ifndef BIX    /* don't allow in bix */
   enterwd("print", MAIN_SS, PRNT_K);
#endif
   enterwd("comment",    READ_SS, CMNT_K);
   enterwd("date",  READ_SS, DATE_K);
   enterwd("first", READ_SS|JOIN_SS, FIRST_K);
   enterwd("last",  READ_SS|JOIN_SS, LAST_K);
   enterwd("forward",    READ_SS|M_RD_SS, FWRD_K);
   enterwd("header",     READ_SS, HEAD_K);
   enterwd("reference",  READ_SS, REFR_K);
   enterwd("resign",     JOIN_SS|READ_SS, RESN_K);
   enterwd("skip",  READ_SS, SKIP_K);
   enterwd("say",   READ_SS, SAY_K);
   enterwd("all",   READ_SS|SHOW_SS, ALL_K);
   enterwd("new",   JOIN_SS|MAIL_SS|SHOW_SS|MOD_SS, NEW_K);
   enterwd("participants",SHOW_SS|MOD_SS, PARTICIP_K);
   enterwd("resume",     SHOW_SS|EDIT_SS, RESUME_K);
   enterwd("status",     MEMO_SS|SHOW_SS|MAIL_SS, STAT_K);
   enterwd("who",   SHOW_SS|MAIN_SS, WHO_K);
   enterwd("profile",    EDIT_SS, PROF_K);
   enterwd("scratchpad",EDIT_SS|SHOW_SS, SCRAT_K);
   enterwd("set",   EDIT_SS|OPTION_SS, SET_K);
   enterwd("backward",   READ_SS, BKWD_K);
   enterwd("withdraw",   MAIL_SS|READ_SS, WTHD_K);
   enterwd("reply", MAIL_SS|M_RD_SS, REPLY_K);
   enterwd("add",   RD_AD_SS|MOD_SS, ADD_K);
   enterwd("list",  RD_AD_SS|M_SD_SS, LIST_K);
   enterwd("member",     MOD_SS, PARTICIP_K);
   enterwd("remove",     MOD_SS, REM_K);
   enterwd("topic", MOD_SS|JOIN_SS, TOPIC_K);
   enterwd("terminate",  MOD_SS, TERM_K);
   enterwd("??",    ALL_SS, HELP_K);
   enterwd("help",  MEMO_SS|M_RD_SS|M_SD_SS, HELP_K);
   enterwd("synonym",   OPTION_SS, SYN_K);
   enterwd("upload",    READ_SS|OPTION_SS, UPLD_K);
   enterwd("download",  READ_SS|OPTION_SS, DNLD_K);
   enterwd("password",  MAIN_SS, PASS_K);
   enterwd("terminal",  OPTION_SS, TERM_K);
   enterwd("option",    MAIN_SS|SHOW_SS, OPT_K);
   enterwd("order",     JOIN_SS, MOVE_K);
   enterwd("workfile",  SHOW_SS|EDIT_SS, WORK_K);
   enterwd("change",    MOD_SS, CHNG_K);

   enterwd("to",        M_SD_SS|MEMO_SS|READ_SS, TO_K);
   enterwd("quit",      ~ MAIN_SS, QUIT_K);
   enterwd("leave",     M_RD_SS, LEAVE_K);
   enterwd("delete",    M_RD_SS|MEMO_SS|MAIL_SS|MOD_SS, DEL_K);
   enterwd("send",      M_SD_SS|MEMO_SS, SEND_K);
/****
   enterwd("accept",    M_RD_SS, ACCEPT_K);
***/
   enterwd("cc",        M_SD_SS, CC_K);
   enterwd("from",      M_SD_SS, FROM_K);
   enterwd("subject",   M_SD_SS, SUBJ_K);
   enterwd("??",        MEMO_SS, HELP_K);
   enterwd("help", RD_AD_SS, HELP_K);
   enterwd("??",   RD_AD_SS, HELP_K);
   enterwd("original",   M_RD_SS|READ_SS, ORIG_K);
   enterwd("copy", READ_SS, COPY_K);
   enterwd("search", READ_SS, SRCH_K);
   enterwd("january",    DATE_SS, 1);
   enterwd("february",   DATE_SS, 2);
   enterwd("march", DATE_SS, 3);
   enterwd("april", DATE_SS, 4);
   enterwd("may",   DATE_SS, 5);
   enterwd("june",  DATE_SS, 6);
   enterwd("july",  DATE_SS, 7);
   enterwd("august",     DATE_SS, 8);
   enterwd("september",  DATE_SS, 9);
   enterwd("october",    DATE_SS, 10);
   enterwd("november",   DATE_SS, 11);
   enterwd("december",   DATE_SS, 12);
 }


enterwd(word,ssys,kval)    /* enter word in table vp */
char *word;
ushort ssys;
int kval;
{
    struct wdtbl *vp, *vp2, *nvp;
    int cmp;

    vp = Vocab;
    while (vp != NULL) {
       vp2 = vp;
       if ((cmp = strcmp(word,vp->wrd)) == 0) { /* oops? */
          vp->ss |= ssys;
          return;
          }
       else if (cmp < 0)
          vp = vp->left;
       else
          vp = vp->right;
       }
    nvp = (struct wdtbl *) malloc(sizeof(struct wdtbl));
    nvp->wrd = word;
    nvp->ss = ssys;
    nvp->key = kval;
    nvp->left = nvp->right = NULL;
    if (cmp < 0)
       vp2->left = nvp;
    else
       vp2->right = nvp;
}
