/**************************************************************************
*    CoSy conferencing system, written by Alastair Mayer
*    
*    Copyright (C) 1984 University of Guelph
*
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program; if not, write to the Free Software
*    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*
***************************************************************************/

/************ New logging routine  - (c) 1985 Alastair Mayer *********/
#ifdef NOLOGGING
 logger(s1,s2) /* dummy */
char *s1, *s2;
{ return; }

#else

#ifdef SYS_V
/* include System V lock fns */
#include <unistd.h>
#endif

#include <errno.h>
#ifndef errno
extern int errno;
#endif

FILE *Lfp, *pfp, *popen();

logger(event,conf)   /* log even & maybe conf with time & user info */
char *event, *conf;
{
  static int first = 1;
  static char *logfmt = "dddddddddd %ld uuuuuuuuuuuuuu ttynn speed %s %s\n";
  static char logfile[50];
  time_t timenow, time();
  char lspeed[10];
  char *ttyname();

  if (first) {   /* set up static info */
#ifdef DEBUG
     strcpy(logfile,"/dev/tty");
#else
     strcpy(logfile,LOGFILE);
     strcat(logfile,username);
#endif
     if ((Lfp = fopen(logfile,"a"))==NULL) {
        char cmd[250];
        if (errno != EISDIR) {
           perror("cosylog: ");
           sprintf(cmd,"cosylogprob %s cant access cosylog, errno= %d",username,errno);
           system(cmd);
           }
        exit(0);     /*** if can't log, can't continue ***/
        }
     if (Lfp != NULL)
        setbuf(Lfp, NULL);    /* don't buffer this one */
#ifdef SYS_V
     /*** now lock log file so won't be disturbed by billing rtns **/
     if (Lfp != NULL) {
        rewind(Lfp);
#ifdef FCHR_MAX
        lockf(fileno(Lfp), F_LOCK, FCHR_MAX);
#else
        lockf(fileno(Lfp), F_LOCK, MAXINT);
#endif
        fseek(Lfp, 0L, 2);
        }
     /**** whole file now locked ******/
#endif
     timenow = time(0);
#ifndef BSD4      /* popen doesn't work as expected on Berkely */
     if ((pfp=popen("stty","r")) != NULL) {
        fscanf(pfp,"%*s%s",lspeed);
        pclose(pfp);
        }
     else
        strcpy(lspeed,"999");
#else
    strcpy(lspeed,"");
#endif
/****
     switch (sgty->sg_ispeed) {
       case    B0: lspeed = 0; break;
       case   B50: lspeed = 50; break;
       case   B75: lspeed = 75; break;
       case  B110: lspeed = 110; break;
       case  B134: lspeed = 134; break;
       case  B150: lspeed = 150; break;
       case  B300: lspeed = 300; break;
       case  B600: lspeed = 600; break;
       case B1200: lspeed = 1200; break;
       case B2400: lspeed = 2400; break;
       case B4800: lspeed = 4800; break;
       case B9600: lspeed = 9600; break;
       case  EXTA: lspeed = 1; break;
       case  EXTB: lspeed = 2; break;
       default:    lspeed = 3; break;
       }
*****/
     sprintf(logfmt,"%ld|%%ld|%s|%s|%s|%%s|%%s\n",timenow,username,
             (ttyname(0)+5),lspeed);
#ifdef DEBUG
 puts("LOGFMT");
 puts(logfmt);
#endif
     first = 0;
     }
  timenow = time(0);
  if (Lfp != NULL) {
     fprintf(Lfp,logfmt,timenow,event,conf);
     if (strcmp(event,"LOGOFF")==0)    /* should all be over now */
        fclose(Lfp);
     }
}
#endif
