/**************************************************************************
*    CoSy conferencing system, written by Alastair Mayer
*    
*    Copyright (C) 1984 University of Guelph
*
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program; if not, write to the Free Software
*    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*
***************************************************************************/

/** routine for re-registration.  Check if user is now in UserList, */
/*  if not, then call reregistration procedure to collect billing   */
/*  info and put him in UserList.      - Alastair Mayer 31 Oct 85  **/

rereg()  /* check and maybe reregister user */
{
   FILE *fp, *fopen();
   char chkname[NMSIZE+5];
   int done = 0;

   if ((fp = fopen(mkpath(ULIST),"r")) == NULL ) {
      /* no userlist? */
      fputs("cosy: rereg: cant open userlist.\n",stderr);
      return(-1);
      }
   while (!done) {    /* check UserList for name */
      if (fscanf(fp,"%14s%*[^\n]",chkname)==EOF)
         break;
      done = (strcmp(chkname,username)==0);
      }
   fclose(fp);
   if (done) /* found it */
      return(0);

   /* not done, so do it */
   {
      char cmd[50];

      sprintf(cmd,"/byte/testreg/reregister %s",username);
#ifdef POPEN_FIXED
      if ((fp = popen(cmd,"r")) == NULL) {
         puts("Sorry, unable to initiate re-registration procedure.");
         puts("Reregistrations not allowed, or system problem.");
         return(1);
         }
#endif
      if (system(cmd)) {   /* bad return status */
         puts("Bad return status from re-registration procedure.");
         puts("Sorry, unable to continue session.");
         return(1);
         }
      else
         return(0);
      }
}
