/**************************************************************************
*    CoSy conferencing system, written by Alastair Mayer
*    
*    Copyright (C) 1984 University of Guelph
*
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program; if not, write to the Free Software
*    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*
***************************************************************************/

/*******************************************************
* COSY(tm) Computer-Based Conferencing System          *
* Copyright (C) 1983, 1984, 1985, University of Guelph *
* Written by: Alastair J.W. Mayer                      *
*******************************************************/

startup()
{
   FILE * fp, *fopen();
   FILE * fdp;  /* for profile kluge */

   print_flag = OFF;
   file_flag  = OFF;
   joined_flag = OFF;
   hi_bye(HELLO_K);
   rpt_stats();
   /* kluge for former cosy1 users, to create profile */
   if ((fp = fopen(mkpath(PROF, username,""), "r")) == NULL) {
      if ((fp = fopen(mkpath(PROF, username,""), "w")) != NULL) {
         if ((fdp = fopen(NU_PROFYL, "r")) != NULL) {
            filecopy(fdp, fp);
            fclose(fdp);
         }
         fclose(fp);
         fp = fopen(mkpath(PROF, username,""), "r");  /* re-open read */
      }
   }
   if (fp != NULL) {
      parse(fp);   /* execute user profile */
      fclose(fp);
   }
}


hi_bye(key)
int   key;
{
   char   usrlok[50];
   int   fd;
   extern int   errno;
   char   *fname;
   char   *tymestamp();
   FILE * fopen(), *fp;
   char   *ctime(); 
   long int   act, acc_time();
   char   *add_user();
   char   *getpswd();
   char   *cmd;
   char   pidstr[10];
   int   pid;
   int   strikes = 3;
   int   newuser, notnew;
   char   *crypt();
   int   badpass;
   char   maiden[40];   /* mothers maiden name from passwd file*/
   int   sig_hup();    /* hangup handler */
#include <pwd.h>
   struct passwd *getpwnam(), *pwd;
   char   *pwkey = "xx";

#ifdef DEBUG
   printf("HELLO/GOODBYE subsection called\n");
#endif
   cmd = usrlok;   /* cmd and usrlok now aliased */
   switch (key) {
   case HELLO_K:
#ifdef DEBUG
      printf(" HELLO function invoked\n");
#endif
try:        
      username[0] = '\0';
      while (strlen(username) == 0) {
         getlin(0, mesg("Name? "));
         scan(username); /* extract user name */
      }
      if (strcmp("whiz", username) == 0)
         strcpy(username, "Wizard");
      newuser = (0 == (notnew = strcmp("new", username)));
      fname = mkpath(UNODE, username, "");
      if (notnew && ((fp = fopen(fname, "r")) == NULL)) {
         printf(mesg("'%s' not registered\n"), username);
         printf("To register, enter 'new'.\n");
         if (strikes-- > 0) 
            goto try;
         exit(0);   /* terminate if not registered */
      } else if (newuser) {
         strcpy(username, add_user(username));
         Privilege = 2; /* all new users */
         logger("REGISTER", "");
      } else {
         fclose(fp);
         act = acc_time(mkpath(PROF, username, ""));
#ifdef UNIX_IDS
         if ((pwd = getpwnam(username)) != NULL) {
            if (strlen(pwd->pw_passwd) > 0) {
               strncpy(pwkey, pwd->pw_passwd, 2);
               if (strcmp(pwd->pw_passwd, crypt(getpswd("Password: "), pwkey)) != 0) {
                  if (strikes-- > 0) {
                     puts("Error"); 
                     goto try;
                  }
                  puts("Goodbye.."); 
                  exit(0);
               }
            }
         } else {
#endif
            fp = fopen(mkpath(PASSWD, username, ""), "r");
            if (fp != NULL) {
               fscanf(fp, "%s", Passwd);
               if (fscanf(fp, "%d", &Privilege) == EOF)
                  Privilege = 2;
               fscanf(fp, "%s", maiden);   /* if need to encrypt */
               fclose(fp);
               if (Passwd[0] != '\0') {
                  if (Passwd[0] == 'X' && Passwd[1] == '/') {
                     /* already encrypted */
                     badpass = strcmp(crypt(getpswd("Password: "), "X/"), Passwd);
                  } else {  /* not encrypted, encrypt it */
                     badpass = strcmp(getpswd("Password: "), Passwd);
                     if (!badpass) {
                        fp = fopen(mkpath(PASSWD, username, ""), "w");
                        strcpy(Passwd, crypt(Passwd, "X/"));
                        if (fp != NULL) {
/* code folded from here */
   fprintf(fp, "%s %d %s\n", Passwd, Privilege, maiden);
   fclose(fp);
/* unfolding */
                        }
                     }
                  }
                  if (badpass) {
                     if (strikes-- > 0) {
                        puts("Error");
                        goto try;
                     }
                     logger("BADPASSWD", "");
                     tout("Goodbye..");
                     exit(0);
                  }
               }
            }
#ifdef UNIX_IDS
         }
#endif
      }
      errno = 0;
      if (access("/tmp/CU", 7)) {  /* can't access, try to make it */
         makedir("/tmp/CU", "");
      }
      strcpy(usrlok, "/tmp/CU/");
      strcat(usrlok, username);
      fd = creat(usrlok, 0400);
      if (errno != 0) {
         fp = fopen(usrlok, "r");
         fscanf(fp, "%d", &pid);
         fclose(fp);
         if (kill(pid, SIGALRM) == -1) {
            chmod(usrlok, 0600);  /* enable write */
            fd = open(usrlok, 2);
            chmod(usrlok, 0400); /* disable write */
         } else {
            printf(mesg("'%s' already logged on.  Goodbye.\n"), username);
            exit(1);
         }
      }
      sprintf(pidstr, "%d \n", getpid());
      write(fd, pidstr, strlen(pidstr));
      close(fd);
      /******** ignore 'last on' herald
   if (act > 0)
#ifdef UTS
        printf("'%s' last on at %s",username,ctime( act ));
#else
        printf("'%s' last on at %s",username,ctime( &act ));
#endif
***************/
      if (strcmp(username, "al") == 0) 
         Privilege = 11;
      if (strcmp(username, "Wizard") == 0) 
         Privilege = 8;
      if (strcmp(username, "sysmgr") == 0) 
         Privilege = 8;
      if (strcmp(username, "gbond") == 0) 
         Privilege = 8;

#if REREGS_OK
      /* re-registration hook - for month of Nov '85 only */
      signal(SIGHUP, SIG_DFL);   /* die on hangup during rereg */
      if (rereg() != 0)   /* bad reregistration attempt */
         exit(1);
      signal(SIGHUP, sig_hup);  /* trap it again */
      /* end of hook */
#endif

      fill_list(Ct, Mt, CONF);   /* load conf & mail tree */
      fill_list(Ct, Mt, NUCONF);    /* add any updates */
#ifdef DEBUG
      printf("First conference =");
      if (Ct->ct_first == NULL)
         printf(" NULL\n");
      else
         printf(" %s.", Ct->ct_first->c_name);
#endif
      logger("LOGIN", "");
      break;
   case BYE_K:   
      signal(SIGHUP, SIG_IGN);  /* may get this anytime now.. */
      logger("BYE", "");
      printf(mesg("Goodbye.."));
      if (Fyl != NULL) 
         fclose(Fyl);
      put_list(Ct, Mt);  /* write updated conf list */
      /**** zap empty scratchpad ****/
       {  
         char   *sp;
         long   filesize();

         sp = mkpath(SCRATCH, username, "");
         if (filesize(sp) == 0L)
            unlink(sp);
      }
      /* scratchpad zapped */
      if (Prt != NULL) {  /* then spool print file */
         sprintf(cmd, "cozyprint %s", PrtFyl);
         fflush(stdout);
         system(cmd);
         printf(mesg("Print file queued to printer."));
      }
   case ABORT_K:  
      strcpy(usrlok, "/tmp/CU/");    /* straight to here on error */
      strcat(usrlok, username);
      unlink(usrlok);
      logger("LOGOFF", "");
      printf("'%s' \n", username);
      printf("Off at %s", tymestamp());
      break;
      /*
                  exit(0);   /** commit suicide **/
   default:  
      printf(mesg(" Default (?) invoked \n"));
      break;
   }
}


StrCpy(s, t)  /* copy s to t */
char   *s, *t;
{
   while (*t++ = *s++)
      ;
}


StrCat(s, t) /* catenate s to end of t */
char   *s, *t;
{
   while (*t++ != '\0')
      ;
   *t--;
   while (*t++ = *s++)
      ;
}


