/**************************************************************************
*    CoSy conferencing system, written by Alastair Mayer
*    
*    Copyright (C) 1984 University of Guelph
*
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program; if not, write to the Free Software
*    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*
***************************************************************************/

/*******************************************************
* COSY(tm) Computer-Based Conferencing System          *
* Written by: Alastair J.W. Mayer                      *
*******************************************************/
no_priv(n)  /* check if priv level >= n */
int n;
{
   if (Privilege < n) {
     puts(mesg("No privilege.|Sorry, insufficient privilege for request."));
     return(-1);
     }
   else
     return(0);
}

ch_pass(newusr)   /* change user password */
int newusr;    /* if new user or not */
{ char op[NMSIZE], np1[NMSIZE], np2[NMSIZE];
  int prv;
#ifdef BIX
  char maiden[30];   /* 'mothers maiden name' validity check */
#endif
  FILE *fp, *fopen();
  char *mkpath();
  char *pw, *getpswd();
  char *mesg(), *crypt();

   if (Privilege > 8) {
      getlin(0,mesg("whose?"));
      scan(op);
      if ((fp = fopen(mkpath(PASSWD,op),"r")) == NULL)
      printf(" '%s' has no password file.\n", op);
      else {
#ifdef BIX
         fscanf(fp,"%s %d %s",np2,&prv,maiden);
         printf("Old pass: '%s' Priv: %d Maiden: '%s'\n",
                     np2, prv, maiden);
#else
         fscanf(fp,"%s %d",np2,&prv);
         printf("Old pass: '%s' Priv: %d\n",np2,prv);
#endif
         fclose(fp);
         }
      getlin(0,mesg("Change to?"));
      scan(np1);
      if (yorn(np1,' ')) {
         strcpy(np1,crypt(np1,"X/"));    /* encrypt it first! */
         fp = fopen(mkpath(PASSWD,op),"w");
#ifdef BIX
         fprintf(fp,"%s %d %s\n",np1,prv,maiden);
#else
         fprintf(fp,"%s %d\n",np1,prv);
#endif
         fclose(fp);
         puts(mesg("Password changed."));
         }
      }
 else {
  if (newusr == 0) {
     scan(op);
     if (op[0]=='\0') 
       pw=getpswd("Old password:");
     else pw=op;
     if (strcmp(crypt(pw,"X/"),Passwd) != 0) {
        printf(mesg("Invalid\n")); return;
        }
     }
  scan(np1);
  if (np1[0]=='\0') {
    pw=getpswd("New password:");
    strcpy(np1,pw);
    }
  scan(np2);
  if (np2[0]=='\0') {
    pw=getpswd("Re-enter new password:");
    strcpy(np2,pw);
    }
  if (strcmp(np1,np2) != 0) {
    printf(mesg("Password not changed.\n"));
    return;
    }
  strcpy(np1,crypt(np1,"X/"));   /* encrypt it! */
#ifndef BIX
  if (newusr != 0)
    fp = fopen(mkpath(PASSWD,username),"w");
  else
#endif
  fp = fopen(mkpath(PASSWD,username),"r+");
#ifdef BIX
  fscanf(fp,"%*s %*d %s",maiden);  /* pick this up */
#endif
  rewind(fp);
#ifdef BIX
  fprintf(fp,"%s %d %s\n",np1,Privilege,maiden);
#else
  fprintf(fp,"%s %d\n",np1,Privilege);
#endif
  strcpy(Passwd,np1);
  fclose(fp);
  }
}

forcebye()   /* force logoff if signalled (by sysmgr) */
{
  signal(SIGQUIT,SIG_IGN);
  logger("INTERRUPT","");
  puts(mesg("Logged off by system."));
  hi_bye(BYE_K);
  exit(0);
}

char *getpswd(prompt)  /* like getpass(3), but turn off/on Tymnet echo */
char *prompt;
{
    char *p, *getpass();

    fputs(ECHO_OFF,stderr); fflush(stderr);
    p = getpass(prompt);
    fputs(ECHO_RSTR,stderr); fflush(stderr);
    return(p);
}
